dojo.provide("dojo.iCalendar");
dojo.provide("dojo.iCalendar.Component");
dojo.provide("dojo.iCalendar.Property");
dojo.require("dojo.text.textDirectory");
dojo.require("dojo.date");
dojo.iCalendar=function(_1){
for(prop in dojo.iCalendar.Component.prototype){
this[prop]=dojo.iCalendar.Component.prototype[prop];
}
dojo.iCalendar.Component.call(this,"VCALENDAR",_1);
};
dojo.lang.extend(dojo.iCalendar,{getEvents:function(_2,_3){
var _4=[];
if(dojo.lang.isString(_2)){
var _5=dojo.date.fromIso8601(_2);
}else{
_5=_2;
}
if(dojo.lang.isString(_3)){
var _6=dojo.date.fromIso8601(_3);
}else{
_6=_3;
}
for(var x=0;x<this.components.length;x++){
if(this.components[x].name=="VEVENT"){
evtStart=dojo.date.fromIso8601(this.components[x].dtstart.value);
evtEnd=dojo.date.fromIso8601(this.components[x].dtend.value);
if(((evtStart>=_5)&&(evtStart<=_6))||((evtStart<=_6)&&(evtEnd>=_5))){
_4.push(this.components[x]);
}
}
}
return _4;
}});
dojo.iCalendar.fromText=function(_8){
var _9=dojo.textDirectoryTokeniser.tokenise(_8);
var _a=[];
for(var i=0,begun=false;i<_9.length;i++){
var _c=_9[i];
if(!begun){
if(_c.name=="BEGIN"&&_c.value=="VCALENDAR"){
begun=true;
var _d=[];
}
}else{
if(_c.name=="END"&&_c.value=="VCALENDAR"){
_a.push(new dojo.iCalendar(_d));
begun=false;
}else{
_d.push(_c);
}
}
}
return _a;
};
dojo.iCalendar.Component=function(_e,_f){
this.name=_e;
this.properties=[];
this.components=[];
for(var i=0,context="";i<_f.length;i++){
if(context==""){
if(_f[i].name=="BEGIN"){
context=_f[i].value;
var _11=[];
}else{
this.addProperty(new dojo.iCalendar.Property(_f[i]));
}
}else{
if(_f[i].name=="END"&&_f[i].value==context){
this.addComponent(new dojo.iCalendar.Component(context,_11));
context="";
}else{
_11.push(_f[i]);
}
}
}
};
dojo.lang.extend(dojo.iCalendar.Component,{addProperty:function(_12){
this.properties.push(_12);
this[_12.name.toLowerCase()]=_12;
},addComponent:function(_13){
this.components.push(_13);
},toString:function(){
return "[iCalendar.Component; "+this.name+", "+this.properties.length+" properties, "+this.components.length+" components]";
}});
dojo.iCalendar.Property=function(_14){
this.name=_14.name;
this.group=_14.group;
this.params=_14.params;
this.value=_14.value;
};
dojo.lang.extend(dojo.iCalendar.Property,{toString:function(){
return "[iCalenday.Property; "+this.name+": "+this.value+"]";
}});

