dojo.provide("dojo.reflect");
if(!dj_global){
var dj_global=this;
}
dojo.reflect={};
dojo.reflect.$unknownType=function(){
};
dojo.reflect.ParameterInfo=function(_1,_2){
this.name=_1;
this.type=(_2)?_2:dojo.reflect.$unknownType;
};
dojo.reflect.PropertyInfo=function(_3,_4){
this.name=_3;
this.type=(_4)?_4:dojo.reflect.$unknownType;
};
dojo.reflect.MethodInfo=function(_5,fn){
var _7=function(f){
var o={};
var s=f.toString();
var _b=((s.substring(s.indexOf("(")+1,s.indexOf(")"))).replace(/\s+/g,"")).split(",");
o.parameters=[];
for(var i=0;i<_b.length;i++){
o.parameters.push(new dojo.reflect.ParameterInfo(_b[i]));
}
o.body=(s.substring(s.indexOf("{")+1,s.lastIndexOf("}"))).replace(/(^\s*)|(\s*$)/g,"");
return o;
};
var _d=_7(fn);
var p=_d.parameters;
var _f=_d.body;
this.name=(_5)?_5:"anonymous";
this.getParameters=function(){
return p;
};
this.getNullArgumentsObject=function(){
var a=[];
for(var i=0;i<p.length;i++){
a.push(null);
}
return a;
};
this.getBody=function(){
return _f;
};
this.type=Function;
this.invoke=function(src,_13){
return fn.apply(src,_13);
};
};
dojo.reflect.Activator=new (function(){
this.createInstance=function(_14,_15){
switch(typeof (_14)){
case "function":
var o={};
_14.apply(o,_15);
return o;
case "string":
var o={};
(dojo.reflect.Reflector.getTypeFromString(_14)).apply(o,_15);
return o;
}
throw new Error("dojo.reflect.Activator.createInstance(): no such type exists.");
};
})();
dojo.reflect.Reflector=new (function(){
this.getTypeFromString=function(s){
var _18=s.split("."),i=0,obj=dj_global;
do{
obj=obj[_18[i++]];
}while(i<_18.length&&obj);
return (obj!=dj_global)?obj:null;
};
this.typeExists=function(s){
var _1a=s.split("."),i=0,obj=dj_global;
do{
obj=obj[_1a[i++]];
}while(i<_1a.length&&obj);
return (obj&&obj!=dj_global);
};
this.getFieldsFromType=function(s){
var _1c=s;
if(typeof (s)=="string"){
_1c=this.getTypeFromString(s);
}
var _1d=(new dojo.reflect.MethodInfo(_1c)).getNullArgumentsObject();
return this.getFields(dojo.reflect.Activator.createInstance(s,_1d));
};
this.getPropertiesFromType=function(s){
var _1f=s;
if(typeof (s)=="string"){
_1f=this.getTypeFromString(s);
}
var _20=(new dojo.reflect.MethodInfo(_1f)).getNullArgumentsObject();
return this.getProperties(dojo.reflect.Activator.createInstance(s,_20));
};
this.getMethodsFromType=function(s){
var _22=s;
if(typeof (s)=="string"){
_22=this.getTypeFromString(s);
}
var _23=(new dojo.reflect.MethodInfo(_22)).getNullArgumentsObject();
return this.getMethods(dojo.reflect.Activator.createInstance(s,_23));
};
this.getType=function(o){
return o.constructor;
};
this.getFields=function(obj){
var arr=[];
for(var p in obj){
if(this.getType(obj[p])!=Function){
arr.push(new dojo.reflect.PropertyInfo(p,this.getType(obj[p])));
}else{
arr.push(new dojo.reflect.MethodInfo(p,obj[p]));
}
}
return arr;
};
this.getProperties=function(obj){
var arr=[];
var fi=this.getFields(obj);
for(var i=0;i<fi.length;i++){
if(this.isInstanceOf(fi[i],dojo.reflect.PropertyInfo)){
arr.push(fi[i]);
}
}
return arr;
};
this.getMethods=function(obj){
var arr=[];
var fi=this.getFields(obj);
for(var i=0;i<fi.length;i++){
if(this.isInstanceOf(fi[i],dojo.reflect.MethodInfo)){
arr.push(fi[i]);
}
}
return arr;
};
this.getBaseClass=function(o){
if(o.getType().prototype.prototype.constructor){
return (o.getType()).prototype.prototype.constructor;
}
return Object;
};
this.isInstanceOf=function(o,_32){
return (this.getType(o)==_32);
};
this.isSubTypeOf=function(o,_34){
return (o instanceof _34);
};
this.isBaseTypeOf=function(o,_36){
return (_36 instanceof o);
};
})();
dojo.provide("dojo.reflect.reflection");

