dojo.provide("dojo.widget.CiviCrmDatePicker");
dojo.provide("dojo.widget.HtmlCiviCrmDatePicker");
dojo.require("dojo.widget.*");
dojo.require("dojo.event.*");
dojo.require("dojo.widget.DatePicker");
dojo.require("dojo.widget.html.DatePicker");
dojo.require("dojo.widget.html.TimePicker");
dojo.require("dojo.html");
dojo.widget.HtmlCiviCrmDatePicker=function(){
this.widgetType="CiviCrmDatePicker";
this.idPrefix="scheduled_date_time";
this.mode="datetime";
this.datePicker=null;
this.timePicker=null;
this.dateHolderTd=null;
this.timeHolderTd=null;
this.formItemsTd=null;
this.formItemsTr=null;
this.monthSelect=null;
this.daySelect=null;
this.yearSelect=null;
this.hourSelect=null;
this.minSelect=null;
this.apSelect=null;
this.templatePath=dojo.uri.dojoUri("src/widget/templates/HtmlCiviCrmDatePicker.html");
this.modeFormats={date:"MdY",time:"hiA"};
this.formatMappings={"M":"monthSelect","d":"daySelect","Y":"yearSelect","h":"hourSelect","i":"minSelect","A":"apSelect"};
this.setDateSelects=function(){
var _1=this.datePicker.date;
this.monthSelect.value=new String(_1.getMonth()+1);
this.daySelect.value=new String(_1.getDate());
this.yearSelect.value=new String(_1.getFullYear());
};
this.setTimeSelects=function(){
var st=this.timePicker.selectedTime;
this.hourSelect.value=new String(st.hour);
this.minSelect.value=new String(st.minute);
this.apSelect.value=st.amPm.toUpperCase();
};
this.fillInTemplate=function(_3,_4){
var nr=_4["dojo:"+this.widgetType.toLowerCase()]["nodeRef"];
var _6={};
while(nr.firstChild){
if(nr.firstChild.name){
_6[nr.firstChild.name]=nr.firstChild;
}
this.formItemsTd.appendChild(nr.firstChild);
}
if(this.mode.indexOf("date")!=-1){
this.datePicker=dojo.widget.createWidget("DatePicker",{},this.dateHolderTd);
dojo.event.connect(this.datePicker,"onSetDate",this,"setDateSelects");
var _7=this.modeFormats.date;
for(var x=0;x<_7.length;x++){
this[this.formatMappings[_7[x]]]=_6[this.idPrefix+"["+_7[x]+"]"];
fr=this[this.formatMappings[_7[x]]].form;
}
}
if(this.mode.indexOf("time")!=-1){
this.timePicker=dojo.widget.createWidget("TimePicker",{},this.timeHolderTd);
dojo.event.connect(this.timePicker,"onSetTime",this,"setTimeSelects");
var _7=this.modeFormats.time;
for(var x=0;x<_7.length;x++){
this[this.formatMappings[_7[x]]]=_6[this.idPrefix+"["+_7[x]+"]"];
}
}
};
this.unhide=function(){
this.formItemsTr.style.display="";
};
this.postCreate=function(){
dojo.event.kwConnect({type:"before",srcObj:dojo.html.getParentByType(this.domNode,"form"),srcFunc:"onsubmit",targetObj:this,targetFunc:"unhide"});
};
};
dojo.inherits(dojo.widget.HtmlCiviCrmDatePicker,dojo.widget.HtmlWidget);
dojo.widget.tags.addParseTreeHandler("dojo:civicrmdatepicker");

