dojo.provide("dojo.widget.TabPane");
dojo.provide("dojo.widget.html.TabPane");
dojo.provide("dojo.widget.Tab");
dojo.provide("dojo.widget.html.Tab");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.LayoutPane");
dojo.require("dojo.event.*");
dojo.require("dojo.html");
dojo.require("dojo.style");
dojo.widget.html.TabPane=function(){
dojo.widget.html.LayoutPane.call(this);
};
dojo.inherits(dojo.widget.html.TabPane,dojo.widget.html.LayoutPane);
dojo.lang.extend(dojo.widget.html.TabPane,{widgetType:"TabPane",labelPosition:"top",useVisibility:false,templateCssPath:dojo.uri.dojoUri("src/widget/templates/HtmlTabPane.css"),selectedTab:"",fillInTemplate:function(_1,_2){
dojo.widget.html.TabPane.superclass.fillInTemplate.call(this,_1,_2);
dojo.style.insertCssFile(this.templateCssPath,null,true);
dojo.html.prependClass(this.domNode,"dojoTabPane");
},postCreate:function(_3,_4){
this.ul=document.createElement("ul");
dojo.html.addClass(this.ul,"tabs");
dojo.html.addClass(this.ul,this.labelPosition);
for(var i=0;i<this.children.length;i++){
this._setupTab(this.children[i]);
}
dojo.widget.html.TabPane.superclass.postCreate.call(this,_3,_4);
this.filterAllowed(this,"labelPosition",["top","bottom"]);
this.labelPanel=dojo.widget.createWidget("LayoutPane",{layoutAlign:this.labelPosition});
this.labelPanel.domNode.appendChild(this.ul);
dojo.widget.html.TabPane.superclass.addChild.call(this,this.labelPanel);
dojo.lang.setTimeout(this,this.onResized,50);
},addChild:function(_6,_7,_8,_9,_a){
this._setupTab(_6);
dojo.widget.html.TabPane.superclass.addChild.call(this,_6,_7,_8,_9,_a);
},_setupTab:function(_b){
_b.layoutAlign="client";
_b.domNode.style.display="none";
dojo.html.prependClass(_b.domNode,"dojoTabPanel");
_b.li=document.createElement("li");
var _c=document.createElement("span");
_c.innerHTML=_b.label;
dojo.html.disableSelection(_c);
_b.li.appendChild(_c);
this.ul.appendChild(_b.li);
var _d=this;
dojo.event.connect(_b.li,"onclick",function(){
_d.selectTab(_b);
});
if(!this.selectedTabWidget||this.selectedTab==_b.widgetId||_b.selected){
this.selectedTabWidget=_b;
}
},selectTab:function(_e){
if(this.selectedTabWidget){
this._hideTab(this.selectedTabWidget);
}
this.selectedTabWidget=_e;
this._showTab(_e);
},_showTab:function(_f){
dojo.html.addClass(_f.li,"current");
_f.selected=true;
if(this.useVisibility&&!dojo.render.html.ie){
_f.domNode.style.visibility="visible";
}else{
_f.show();
}
},_hideTab:function(tab){
dojo.html.removeClass(tab.li,"current");
tab.selected=false;
if(this.useVisibility){
tab.domNode.style.visibility="hidden";
}else{
tab.hide();
}
},onResized:function(){
if(this.selectedTabWidget){
this.selectTab(this.selectedTabWidget);
}
dojo.widget.html.TabPane.superclass.onResized.call(this);
}});
dojo.widget.tags.addParseTreeHandler("dojo:TabPane");
dojo.lang.extend(dojo.widget.Widget,{label:"",selected:false});
dojo.widget.html.Tab=function(){
dojo.widget.html.LayoutPane.call(this);
};
dojo.inherits(dojo.widget.html.Tab,dojo.widget.html.LayoutPane);
dojo.lang.extend(dojo.widget.html.Tab,{widgetType:"Tab"});
dojo.widget.tags.addParseTreeHandler("dojo:Tab");

