dojo.provide("dojo.widget.TimePicker");
dojo.provide("dojo.widget.TimePicker.util");
dojo.require("dojo.widget.DomWidget");
dojo.widget.TimePicker=function(){
dojo.widget.Widget.call(this);
this.widgetType="TimePicker";
this.isContainer=false;
this.toRfcDateTime=dojo.widget.TimePicker.util.toRfcDateTime;
this.fromRfcDateTime=dojo.widget.TimePicker.util.fromRfcDateTime;
this.toAmPmHour=dojo.widget.TimePicker.util.toAmPmHour;
this.fromAmPmHour=dojo.widget.TimePicker.util.fromAmPmHour;
};
dojo.inherits(dojo.widget.TimePicker,dojo.widget.Widget);
dojo.widget.tags.addParseTreeHandler("dojo:timepicker");
dojo.requireAfterIf("html","dojo.widget.html.TimePicker");
dojo.widget.TimePicker.util=new function(){
this.toRfcDateTime=function(_1){
if(!_1){
_1=new Date();
}
var _2=_1.getFullYear();
var _3=_1.getMonth()+1;
if(_3<10){
_3="0"+_3.toString();
}
var _4=_1.getDate();
if(_4<10){
_4="0"+_4.toString();
}
var _5=_1.getHours();
if(_5<10){
_5="0"+_5.toString();
}
var _6=_1.getMinutes();
if(_6<10){
_6="0"+_6.toString();
}
var _7="00";
var _8=_1.getTimezoneOffset();
var _9=parseInt(_8/60);
if(_9>-10&&_9<0){
_9="-0"+Math.abs(_9);
}else{
if(_9<10){
_9="+0"+_9.toString();
}else{
if(_9>=10){
_9="+"+_9.toString();
}
}
}
var _a=_8%60;
if(_a<10){
_a="0"+_a.toString();
}
return _2+"-"+_3+"-"+_4+"T"+_5+":"+_6+":"+_7+_9+":"+_a;
};
this.fromRfcDateTime=function(_b,_c){
var _d=new Date();
if(!_b||!_b.split("T")[1]){
if(_c){
_d.setMinutes(Math.floor(_d.getMinutes()/5)*5);
}else{
_d.setMinutes(0);
}
}else{
var _e=_b.split("T")[1].split(":");
var _d=new Date();
_d.setHours(_e[0]);
_d.setMinutes(_e[1]);
}
return _d;
};
this.toAmPmHour=function(_f){
var _10=_f;
var _11=true;
if(_10==0){
_10=12;
}else{
if(_10>12){
_10=_10-12;
_11=false;
}else{
if(_10==12){
_11=false;
}
}
}
return [_10,_11];
};
this.fromAmPmHour=function(_12,_13){
var _14=parseInt(_12,10);
if(_13&&_14==12){
_14=0;
}else{
if(!_13&&_14<12){
_14=_14+12;
}
}
return _14;
};
};

