dojo.provide("dojo.widget.ToolbarContainer");
dojo.provide("dojo.widget.html.ToolbarContainer");
dojo.provide("dojo.widget.Toolbar");
dojo.provide("dojo.widget.html.Toolbar");
dojo.provide("dojo.widget.ToolbarItem");
dojo.provide("dojo.widget.html.ToolbarButtonGroup");
dojo.provide("dojo.widget.html.ToolbarButton");
dojo.provide("dojo.widget.html.ToolbarDialog");
dojo.provide("dojo.widget.html.ToolbarMenu");
dojo.provide("dojo.widget.html.ToolbarSeparator");
dojo.provide("dojo.widget.html.ToolbarSpace");
dojo.provide("dojo.widget.Icon");
dojo.require("dojo.widget.*");
dojo.require("dojo.html");
dojo.widget.html.ToolbarContainer=function(){
dojo.widget.HtmlWidget.call(this);
this.widgetType="ToolbarContainer";
this.isContainer=true;
this.templateString="<div class=\"toolbarContainer\" dojoAttachPoint=\"containerNode\"></div>";
this.templateCssPath=dojo.uri.dojoUri("src/widget/templates/HtmlToolbar.css");
this.getItem=function(_1){
if(_1 instanceof dojo.widget.ToolbarItem){
return _1;
}
for(var i=0;i<this.children.length;i++){
var _3=this.children[i];
if(_3 instanceof dojo.widget.html.Toolbar){
var _4=_3.getItem(_1);
if(_4){
return _4;
}
}
}
return null;
};
this.getItems=function(){
var _5=[];
for(var i=0;i<this.children.length;i++){
var _7=this.children[i];
if(_7 instanceof dojo.widget.html.Toolbar){
_5=_5.concat(_7.getItems());
}
}
return _5;
};
this.enable=function(){
for(var i=0;i<this.children.length;i++){
var _9=this.children[i];
if(_9 instanceof dojo.widget.html.Toolbar){
_9.enable.apply(_9,arguments);
}
}
};
this.disable=function(){
for(var i=0;i<this.children.length;i++){
var _b=this.children[i];
if(_b instanceof dojo.widget.html.Toolbar){
_b.disable.apply(_b,arguments);
}
}
};
this.select=function(_c){
for(var i=0;i<this.children.length;i++){
var _e=this.children[i];
if(_e instanceof dojo.widget.html.Toolbar){
_e.select(arguments);
}
}
};
this.deselect=function(_f){
for(var i=0;i<this.children.length;i++){
var _11=this.children[i];
if(_11 instanceof dojo.widget.html.Toolbar){
_11.deselect(arguments);
}
}
};
this.getItemsState=function(){
var _12={};
for(var i=0;i<this.children.length;i++){
var _14=this.children[i];
if(_14 instanceof dojo.widget.html.Toolbar){
dojo.lang.mixin(_12,_14.getItemsState());
}
}
return _12;
};
this.getItemsActiveState=function(){
var _15={};
for(var i=0;i<this.children.length;i++){
var _17=this.children[i];
if(_17 instanceof dojo.widget.html.Toolbar){
dojo.lang.mixin(_15,_17.getItemsActiveState());
}
}
return _15;
};
this.getItemsSelectedState=function(){
var _18={};
for(var i=0;i<this.children.length;i++){
var _1a=this.children[i];
if(_1a instanceof dojo.widget.html.Toolbar){
dojo.lang.mixin(_18,_1a.getItemsSelectedState());
}
}
return _18;
};
};
dojo.inherits(dojo.widget.html.ToolbarContainer,dojo.widget.HtmlWidget);
dojo.widget.tags.addParseTreeHandler("dojo:toolbarContainer");
dojo.widget.html.Toolbar=function(){
dojo.widget.HtmlWidget.call(this);
this.widgetType="Toolbar";
this.isContainer=true;
this.templateString="<div class=\"toolbar\" dojoAttachPoint=\"containerNode\" unselectable=\"on\" dojoOnMouseover=\"_onmouseover\" dojoOnMouseout=\"_onmouseout\" dojoOnClick=\"_onclick\" dojoOnMousedown=\"_onmousedown\" dojoOnMouseup=\"_onmouseup\"></div>";
this._getItem=function(_1b){
var _1c=new Date();
var _1d=null;
while(_1b&&_1b!=this.domNode){
if(dojo.html.hasClass(_1b,"toolbarItem")){
var _1e=dojo.widget.manager.getWidgetsByFilter(function(w){
return w.domNode==_1b;
});
if(_1e.length==1){
_1d=_1e[0];
break;
}else{
if(_1e.length>1){
dojo.raise("Toolbar._getItem: More than one widget matches the node");
}
}
}
_1b=_1b.parentNode;
}
return _1d;
};
this._onmouseover=function(e){
var _21=this._getItem(e.target);
if(_21&&_21._onmouseover){
_21._onmouseover(e);
}
};
this._onmouseout=function(e){
var _23=this._getItem(e.target);
if(_23&&_23._onmouseout){
_23._onmouseout(e);
}
};
this._onclick=function(e){
var _25=this._getItem(e.target);
if(_25&&_25._onclick){
_25._onclick(e);
}
};
this._onmousedown=function(e){
var _27=this._getItem(e.target);
if(_27&&_27._onmousedown){
_27._onmousedown(e);
}
};
this._onmouseup=function(e){
var _29=this._getItem(e.target);
if(_29&&_29._onmouseup){
_29._onmouseup(e);
}
};
var _2a=this.addChild;
this.addChild=function(_2b,pos,_2d){
var _2e=dojo.widget.ToolbarItem.make(_2b,null,_2d);
var ret=_2a.call(this,_2e,null,pos,null);
return ret;
};
this.push=function(){
for(var i=0;i<arguments.length;i++){
this.addChild(arguments[i]);
}
};
this.getItem=function(_31){
if(_31 instanceof dojo.widget.ToolbarItem){
return _31;
}
for(var i=0;i<this.children.length;i++){
var _33=this.children[i];
if(_33 instanceof dojo.widget.ToolbarItem&&_33._name==_31){
return _33;
}
}
return null;
};
this.getItems=function(){
var _34=[];
for(var i=0;i<this.children.length;i++){
var _36=this.children[i];
if(_36 instanceof dojo.widget.ToolbarItem){
_34.push(_36);
}
}
return _34;
};
this.getItemsState=function(){
var _37={};
for(var i=0;i<this.children.length;i++){
var _39=this.children[i];
if(_39 instanceof dojo.widget.ToolbarItem){
_37[_39._name]={selected:_39._selected,enabled:_39._enabled};
}
}
return _37;
};
this.getItemsActiveState=function(){
var _3a=this.getItemsState();
for(var _3b in _3a){
_3a[_3b]=_3a[_3b].enabled;
}
return _3a;
};
this.getItemsSelectedState=function(){
var _3c=this.getItemsState();
for(var _3d in _3c){
_3c[_3d]=_3c[_3d].selected;
}
return _3c;
};
this.enable=function(){
var _3e=arguments.length?arguments:this.children;
for(var i=0;i<_3e.length;i++){
var _40=this.getItem(_3e[i]);
if(_40 instanceof dojo.widget.ToolbarItem){
_40.enable(false,true);
}
}
};
this.disable=function(){
var _41=arguments.length?arguments:this.children;
for(var i=0;i<_41.length;i++){
var _43=this.getItem(_41[i]);
if(_43 instanceof dojo.widget.ToolbarItem){
_43.disable();
}
}
};
this.select=function(){
for(var i=0;i<arguments.length;i++){
var _45=arguments[i];
var _46=this.getItem(_45);
if(_46){
_46.select();
}
}
};
this.deselect=function(){
for(var i=0;i<arguments.length;i++){
var _48=arguments[i];
var _49=this.getItem(_48);
if(_49){
_49.disable();
}
}
};
this.setValue=function(){
for(var i=0;i<arguments.length;i+=2){
var _4b=arguments[i],value=arguments[i+1];
var _4c=this.getItem(_4b);
if(_4c){
if(_4c instanceof dojo.widget.ToolbarItem){
_4c.setValue(value);
}
}
}
};
};
dojo.inherits(dojo.widget.html.Toolbar,dojo.widget.HtmlWidget);
dojo.widget.tags.addParseTreeHandler("dojo:toolbar");
dojo.widget.ToolbarItem=function(){
dojo.widget.HtmlWidget.call(this);
};
dojo.inherits(dojo.widget.ToolbarItem,dojo.widget.HtmlWidget);
dojo.lang.extend(dojo.widget.ToolbarItem,{templateString:"<span unselectable=\"on\" class=\"toolbarItem\"></span>",_name:null,getName:function(){
return this._name;
},setName:function(_4d){
return this._name=_4d;
},getValue:function(){
return this.getName();
},setValue:function(_4e){
return this.setName(_4e);
},_selected:false,isSelected:function(){
return this._selected;
},setSelected:function(is,_50,_51){
if(!this._toggleItem&&!_50){
return;
}
is=Boolean(is);
if(_50||this._enabled&&this._selected!=is){
this._selected=is;
this.update();
if(!_51){
this._fireEvent(is?"onSelect":"onDeselect");
this._fireEvent("onChangeSelect");
}
}
},select:function(_52,_53){
return this.setSelected(true,_52,_53);
},deselect:function(_54,_55){
return this.setSelected(false,_54,_55);
},_toggleItem:false,isToggleItem:function(){
return this._toggleItem;
},setToggleItem:function(_56){
this._toggleItem=Boolean(_56);
},toggleSelected:function(_57){
return this.setSelected(!this._selected,_57);
},_enabled:true,isEnabled:function(){
return this._enabled;
},setEnabled:function(is,_59,_5a){
is=Boolean(is);
if(_59||this._enabled!=is){
this._enabled=is;
this.update();
if(!_5a){
this._fireEvent(this._enabled?"onEnable":"onDisable");
this._fireEvent("onChangeEnabled");
}
}
return this._enabled;
},enable:function(_5b,_5c){
return this.setEnabled(true,_5b,_5c);
},disable:function(_5d,_5e){
return this.setEnabled(false,_5d,_5e);
},toggleEnabled:function(_5f,_60){
return this.setEnabled(!this._enabled,_5f,_60);
},_icon:null,getIcon:function(){
return this._icon;
},setIcon:function(_61){
var _62=dojo.widget.Icon.make(_61);
if(this._icon){
this._icon.setIcon(_62);
}else{
this._icon=_62;
}
var _63=this._icon.getNode();
if(_63.parentNode!=this.domNode){
if(this.domNode.hasChildNodes()){
this.domNode.insertBefore(_63,this.domNode.firstChild);
}else{
this.domNode.appendChild(_63);
}
}
return this._icon;
},_label:"",getLabel:function(){
return this._label;
},setLabel:function(_64){
var ret=this._label=_64;
if(!this.labelNode){
this.labelNode=document.createElement("span");
this.domNode.appendChild(this.labelNode);
}
this.labelNode.innerHTML="";
this.labelNode.appendChild(document.createTextNode(this._label));
this.update();
return ret;
},update:function(){
if(this._enabled){
dojo.html.removeClass(this.domNode,"disabled");
if(this._selected){
dojo.html.addClass(this.domNode,"selected");
}else{
dojo.html.removeClass(this.domNode,"selected");
}
}else{
this._selected=false;
dojo.html.addClass(this.domNode,"disabled");
dojo.html.removeClass(this.domNode,"down");
dojo.html.removeClass(this.domNode,"hover");
}
this._updateIcon();
},_updateIcon:function(){
if(this._icon){
if(this._enabled){
if(this._cssHover){
this._icon.hover();
}else{
if(this._selected){
this._icon.select();
}else{
this._icon.enable();
}
}
}else{
this._icon.disable();
}
}
},_fireEvent:function(evt){
if(typeof this[evt]=="function"){
var _67=[this];
for(var i=1;i<arguments.length;i++){
_67.push(arguments[i]);
}
this[evt].apply(this,_67);
}
},_onmouseover:function(e){
if(!this._enabled){
return;
}
dojo.html.addClass(this.domNode,"hover");
},_onmouseout:function(e){
dojo.html.removeClass(this.domNode,"hover");
dojo.html.removeClass(this.domNode,"down");
if(!this._selected){
dojo.html.removeClass(this.domNode,"selected");
}
},_onclick:function(e){
if(this._enabled&&!this._toggleItem){
this._fireEvent("onClick");
}
},_onmousedown:function(e){
if(e.preventDefault){
e.preventDefault();
}
if(!this._enabled){
return;
}
dojo.html.addClass(this.domNode,"down");
if(this._toggleItem){
if(this.parent.preventDeselect&&this._selected){
return;
}
this.toggleSelected();
}
},_onmouseup:function(e){
dojo.html.removeClass(this.domNode,"down");
},fillInTemplate:function(_6e,_6f){
if(_6e.name){
this._name=_6e.name;
}
if(_6e.selected){
this.select();
}
if(_6e.disabled){
this.disable();
}
if(_6e.label){
this.setLabel(_6e.label);
}
if(_6e.icon){
this.setIcon(_6e.icon);
}
if(_6e.toggleitem||_6e.toggleItem){
this.setToggleItem(true);
}
}});
dojo.widget.ToolbarItem.make=function(wh,_71,_72){
var _73=null;
if(wh instanceof Array){
_73=dojo.widget.createWidget("ToolbarButtonGroup",_72);
_73.setName(wh[0]);
for(var i=1;i<wh.length;i++){
_73.addChild(wh[i]);
}
}else{
if(wh instanceof dojo.widget.ToolbarItem){
_73=wh;
}else{
if(wh instanceof dojo.uri.Uri){
_73=dojo.widget.createWidget("ToolbarButton",dojo.lang.mixin(_72||{},{icon:new dojo.widget.Icon(wh.toString())}));
}else{
if(_71){
_73=dojo.widget.createWidget(wh,_72);
}else{
if(typeof wh=="string"||wh instanceof String){
switch(wh.charAt(0)){
case "|":
case "-":
case "/":
_73=dojo.widget.createWidget("ToolbarSeparator",_72);
break;
case " ":
if(wh.length==1){
_73=dojo.widget.createWidget("ToolbarSpace",_72);
}else{
_73=dojo.widget.createWidget("ToolbarFlexibleSpace",_72);
}
break;
default:
if(/\.(gif|jpg|jpeg|png)$/i.test(wh)){
_73=dojo.widget.createWidget("ToolbarButton",dojo.lang.mixin(_72||{},{icon:new dojo.widget.Icon(wh.toString())}));
}else{
_73=dojo.widget.createWidget("ToolbarButton",dojo.lang.mixin(_72||{},{label:wh.toString()}));
}
}
}else{
if(wh&&wh.tagName&&/^img$/i.test(wh.tagName)){
_73=dojo.widget.createWidget("ToolbarButton",dojo.lang.mixin(_72||{},{icon:wh}));
}else{
_73=dojo.widget.createWidget("ToolbarButton",dojo.lang.mixin(_72||{},{label:wh.toString()}));
}
}
}
}
}
}
return _73;
};
dojo.widget.html.ToolbarButtonGroup=function(){
dojo.widget.ToolbarItem.call(this);
this.widgetType="ToolbarButtonGroup";
this.isContainer=true;
this.templateString="<span unselectable=\"on\" class=\"toolbarButtonGroup\" dojoAttachPoint=\"containerNode\"></span>";
this.defaultButton="";
var _75=this.addChild;
this.addChild=function(_76,pos,_78){
var _79=dojo.widget.ToolbarItem.make(_76,null,dojo.lang.mixin(_78||{},{toggleItem:true}));
dojo.event.connect(_79,"onSelect",this,"onChildSelected");
var ret=_75.call(this,_79,null,pos,null);
if(_79._name==this.defaultButton||(typeof this.defaultButton=="number"&&this.children.length-1==this.defaultButton)){
_79.select(false,true);
}
return ret;
};
this.getItem=function(_7b){
if(_7b instanceof dojo.widget.ToolbarItem){
return _7b;
}
for(var i=0;i<this.children.length;i++){
var _7d=this.children[i];
if(_7d instanceof dojo.widget.ToolbarItem&&_7d._name==_7b){
return _7d;
}
}
return null;
};
this.getItems=function(){
var _7e=[];
for(var i=0;i<this.children.length;i++){
var _80=this.children[i];
if(_80 instanceof dojo.widget.ToolbarItem){
_7e.push(_80);
}
}
return _7e;
};
this.onChildSelected=function(e){
this.select(e._name);
};
this.enable=function(_82,_83){
for(var i=0;i<this.children.length;i++){
var _85=this.children[i];
if(_85 instanceof dojo.widget.ToolbarItem){
_85.enable(_82,_83);
if(_85._name==this._value){
_85.select(_82,_83);
}
}
}
};
this.disable=function(_86,_87){
for(var i=0;i<this.children.length;i++){
var _89=this.children[i];
if(_89 instanceof dojo.widget.ToolbarItem){
_89.disable(_86,_87);
}
}
};
this._value="";
this.getValue=function(){
return this._value;
};
this.select=function(_8a,_8b,_8c){
for(var i=0;i<this.children.length;i++){
var _8e=this.children[i];
if(_8e instanceof dojo.widget.ToolbarItem){
if(_8e._name==_8a){
_8e.select(_8b,_8c);
this._value=_8a;
}else{
_8e.deselect(true,_8c);
}
}
}
if(!_8c){
this._fireEvent("onSelect",this._value);
this._fireEvent("onChangeSelect",this._value);
}
};
this.setValue=this.select;
this.preventDeselect=false;
};
dojo.inherits(dojo.widget.html.ToolbarButtonGroup,dojo.widget.ToolbarItem);
dojo.widget.tags.addParseTreeHandler("dojo:toolbarButtonGroup");
dojo.widget.html.ToolbarButton=function(){
dojo.widget.ToolbarItem.call(this);
};
dojo.inherits(dojo.widget.html.ToolbarButton,dojo.widget.ToolbarItem);
dojo.widget.tags.addParseTreeHandler("dojo:toolbarButton");
dojo.lang.extend(dojo.widget.html.ToolbarButton,{widgetType:"ToolbarButton",fillInTemplate:function(_8f,_90){
dojo.widget.html.ToolbarButton.superclass.fillInTemplate.call(this,_8f,_90);
dojo.html.addClass(this.domNode,"toolbarButton");
if(this._icon){
this.setIcon(this._icon);
}
if(this._label){
this.setLabel(this._label);
}
if(!this._name){
if(this._label){
this.setName(this._label);
}else{
if(this._icon){
var src=this._icon.getSrc("enabled").match(/[\/^]([^\.\/]+)\.(gif|jpg|jpeg|png)$/i);
if(src){
this.setName(src[1]);
}
}else{
this._name=this._widgetId;
}
}
}
}});
dojo.widget.html.ToolbarDialog=function(){
dojo.widget.html.ToolbarButton.call(this);
};
dojo.inherits(dojo.widget.html.ToolbarDialog,dojo.widget.html.ToolbarButton);
dojo.widget.tags.addParseTreeHandler("dojo:toolbarDialog");
dojo.lang.extend(dojo.widget.html.ToolbarDialog,{widgetType:"ToolbarDialog",fillInTemplate:function(_92,_93){
dojo.widget.html.ToolbarDialog.superclass.fillInTemplate.call(this,_92,_93);
dojo.event.connect(this,"onSelect",this,"showDialog");
dojo.event.connect(this,"onDeselect",this,"hideDialog");
},showDialog:function(e){
dojo.lang.setTimeout(dojo.event.connect,1,document,"onmousedown",this,"deselect");
},hideDialog:function(e){
dojo.event.disconnect(document,"onmousedown",this,"deselect");
}});
dojo.widget.html.ToolbarMenu=function(){
dojo.widget.html.ToolbarDialog.call(this);
this.widgetType="ToolbarMenu";
};
dojo.inherits(dojo.widget.html.ToolbarMenu,dojo.widget.html.ToolbarDialog);
dojo.widget.tags.addParseTreeHandler("dojo:toolbarMenu");
dojo.widget.ToolbarMenuItem=function(){
};
dojo.widget.html.ToolbarSeparator=function(){
dojo.widget.ToolbarItem.call(this);
this.widgetType="ToolbarSeparator";
this.templateString="<span unselectable=\"on\" class=\"toolbarItem toolbarSeparator\"></span>";
this.defaultIconPath=new dojo.uri.dojoUri("src/widget/templates/buttons/-.gif");
var _96=this.fillInTemplate;
this.fillInTemplate=function(_97,_98,_99){
_96.call(this,_97,_98);
this._name=this.widgetId;
if(!_99){
if(!this._icon){
this.setIcon(this.defaultIconPath);
}
this.domNode.appendChild(this._icon.getNode());
}
};
this._onmouseover=this._onmouseout=this._onclick=this._onmousedown=this._onmouseup=null;
};
dojo.inherits(dojo.widget.html.ToolbarSeparator,dojo.widget.ToolbarItem);
dojo.widget.tags.addParseTreeHandler("dojo:toolbarSeparator");
dojo.widget.html.ToolbarSpace=function(){
dojo.widget.html.ToolbarSeparator.call(this);
this.widgetType="ToolbarSpace";
var _9a=this.fillInTemplate;
this.fillInTemplate=function(_9b,_9c,_9d){
_9a.call(this,_9b,_9c,true);
if(!_9d){
dojo.html.addClass(this.domNode,"toolbarSpace");
}
};
};
dojo.inherits(dojo.widget.html.ToolbarSpace,dojo.widget.html.ToolbarSeparator);
dojo.widget.tags.addParseTreeHandler("dojo:toolbarSpace");
dojo.widget.html.ToolbarSelect=function(){
dojo.widget.ToolbarItem.call(this);
this.widgetType="ToolbarSelect";
this.templateString="<span class=\"toolbarItem toolbarSelect\" unselectable=\"on\"><select dojoAttachPoint=\"selectBox\" dojoOnChange=\"changed\"></select></span>";
var _9e=this.fillInTemplate;
this.fillInTemplate=function(_9f,_a0){
_9e.call(this,_9f,_a0,true);
var _a1=_9f.values;
var i=0;
for(var val in _a1){
var opt=document.createElement("option");
opt.setAttribute("value",_a1[val]);
opt.innerHTML=val;
this.selectBox.appendChild(opt);
}
};
this.changed=function(e){
this._fireEvent("onSetValue",this.selectBox.value);
};
var _a6=this.setEnabled;
this.setEnabled=function(is,_a8,_a9){
var ret=_a6.call(this,is,_a8,_a9);
this.selectBox.disabled=!this._enabled;
return ret;
};
this._onmouseover=this._onmouseout=this._onclick=this._onmousedown=this._onmouseup=null;
};
dojo.inherits(dojo.widget.html.ToolbarSelect,dojo.widget.ToolbarItem);
dojo.widget.tags.addParseTreeHandler("dojo:toolbarSelect");
dojo.widget.Icon=function(_ab,_ac,_ad,_ae){
if(arguments.length==0){
throw new Error("Icon must have at least an enabled state");
}
var _af=["enabled","disabled","hover","selected"];
var _b0="enabled";
var _b1=document.createElement("img");
this.getState=function(){
return _b0;
};
this.setState=function(_b2){
if(dojo.lang.inArray(_b2,_af)){
if(this[_b2]){
_b0=_b2;
_b1.setAttribute("src",this[_b0].src);
}
}else{
throw new Error("Invalid state set on Icon (state: "+_b2+")");
}
};
this.setSrc=function(_b3,_b4){
if(/^img$/i.test(_b4.tagName)){
this[_b3]=_b4;
}else{
if(typeof _b4=="string"||_b4 instanceof String||_b4 instanceof dojo.uri.Uri){
this[_b3]=new Image();
this[_b3].src=_b4.toString();
}
}
return this[_b3];
};
this.setIcon=function(_b5){
for(var i=0;i<_af.length;i++){
if(_b5[_af[i]]){
this.setSrc(_af[i],_b5[_af[i]]);
}
}
this.update();
};
this.enable=function(){
this.setState("enabled");
};
this.disable=function(){
this.setState("disabled");
};
this.hover=function(){
this.setState("hover");
};
this.select=function(){
this.setState("selected");
};
this.getSize=function(){
return {width:_b1.width||_b1.offsetWidth,height:_b1.height||_b1.offsetHeight};
};
this.setSize=function(w,h){
_b1.width=w;
_b1.height=h;
return {width:w,height:h};
};
this.getNode=function(){
return _b1;
};
this.getSrc=function(_b9){
if(_b9){
return this[_b9].src;
}
return _b1.src||"";
};
this.update=function(){
this.setState(_b0);
};
for(var i=0;i<_af.length;i++){
var arg=arguments[i];
var _bc=_af[i];
this[_bc]=null;
if(!arg){
continue;
}
this.setSrc(_bc,arg);
}
this.enable();
};
dojo.widget.Icon.make=function(a,b,c,d){
for(var i=0;i<arguments.length;i++){
if(arguments[i] instanceof dojo.widget.Icon){
return arguments[i];
}else{
if(!arguments[i]){
nullArgs++;
}
}
}
return new dojo.widget.Icon(a,b,c,d);
};

