dojo.provide("dojo.widget.Tree");
dojo.provide("dojo.widget.HtmlTree");
dojo.provide("dojo.widget.TreeNode");
dojo.provide("dojo.widget.HtmlTreeNode");
dojo.require("dojo.event.*");
dojo.require("dojo.fx.html");
dojo.require("dojo.widget.Container");
dojo.widget.tags.addParseTreeHandler("dojo:Tree");
dojo.widget.tags.addParseTreeHandler("dojo:TreeNode");
dojo.widget.HtmlTree=function(){
dojo.widget.html.Container.call(this);
};
dojo.inherits(dojo.widget.HtmlTree,dojo.widget.html.Container);
dojo.lang.extend(dojo.widget.HtmlTree,{widgetType:"Tree",domNode:null,templateCssPath:dojo.uri.dojoUri("src/widget/templates/Tree.css"),templateString:"<div class=\"dojoTree\"></div>",selectedNode:null,toggler:null,blankIconSrc:dojo.uri.dojoUri("src/widget/templates/images/treenode_blank.gif").toString(),gridIconSrcT:dojo.uri.dojoUri("src/widget/templates/images/treenode_grid_t.gif").toString(),gridIconSrcL:dojo.uri.dojoUri("src/widget/templates/images/treenode_grid_l.gif").toString(),gridIconSrcV:dojo.uri.dojoUri("src/widget/templates/images/treenode_grid_v.gif").toString(),gridIconSrcP:dojo.uri.dojoUri("src/widget/templates/images/treenode_grid_p.gif").toString(),gridIconSrcC:dojo.uri.dojoUri("src/widget/templates/images/treenode_grid_c.gif").toString(),gridIconSrcX:dojo.uri.dojoUri("src/widget/templates/images/treenode_grid_x.gif").toString(),gridIconSrcY:dojo.uri.dojoUri("src/widget/templates/images/treenode_grid_y.gif").toString(),gridIconSrcZ:dojo.uri.dojoUri("src/widget/templates/images/treenode_grid_z.gif").toString(),expandIconSrcPlus:dojo.uri.dojoUri("src/widget/templates/images/treenode_expand_plus.gif").toString(),expandIconSrcMinus:dojo.uri.dojoUri("src/widget/templates/images/treenode_expand_minus.gif").toString(),iconWidth:18,iconHeight:18,showGrid:true,showRootGrid:true,toggle:"default",toggleDuration:150,publishSelectionTopic:"",publishExpandedTopic:"",publishCollapsedTopic:"",initialize:function(_1,_2){
switch(this.toggle){
case "fade":
this.toggler=new dojo.widget.Tree.FadeToggle();
break;
case "wipe":
this.toggler=new dojo.widget.Tree.WipeToggle();
break;
default:
this.toggler=new dojo.widget.Tree.DefaultToggle();
}
},postCreate:function(){
this.buildTree();
},buildTree:function(){
dojo.html.disableSelection(this.domNode);
for(var i=0;i<this.children.length;i++){
this.children[i].isFirstNode=(i==0)?true:false;
this.children[i].isLastNode=(i==this.children.length-1)?true:false;
var _4=this.children[i].buildNode(this,0);
this.domNode.appendChild(_4);
}
if(!this.showRootGrid){
for(var i=0;i<this.children.length;i++){
this.children[i].expand();
}
}
for(var i=0;i<this.children.length;i++){
this.children[i].startMe();
}
},addChild:function(_5){
if(_5.widgetType!="TreeNode"){
dojo.raise("You can only add TreeNode widgets to a "+this.widgetType+" widget!");
return;
}
if(this.children.length){
var _6=this.children[this.children.length-1];
_6.isLastNode=false;
_6.updateIconTree();
}else{
if(this.widgetType=="TreeNode"){
this.isParent=true;
this.isExpanded=false;
this.updateIcons();
}
_5.isFirstNode=true;
}
if(this.widgetType=="TreeNode"){
var _7=this.depth+1;
var _8=this.tree;
_5.parentNode=this;
_5.isLastNode=true;
}else{
var _7=0;
var _8=this;
_5.isLastNode=true;
}
this.children.push(_5);
var _9=_5.buildNode(_8,_7);
if(this.widgetType=="Tree"){
this.domNode.appendChild(_9);
}else{
this.containerNode.appendChild(_9);
}
_5.startMe();
}});
dojo.widget.HtmlTreeNode=function(){
dojo.widget.HtmlWidget.call(this);
};
dojo.inherits(dojo.widget.HtmlTreeNode,dojo.widget.HtmlWidget);
dojo.lang.extend(dojo.widget.HtmlTreeNode,{widgetType:"TreeNode",isContainer:true,messWithMyChildren:true,domNode:null,continerNode:null,templateString:"<div class=\"dojoTreeNode\"><div dojoAttachPoint=\"containerNode\"></div></div>",childIconSrc:"",childIcon:null,underChildIcon:null,expandIcon:null,title:"",labelNode:null,imgs:null,rowNode:null,tree:null,parentNode:null,depth:0,isFirstNode:false,isLastNode:false,isExpanded:false,isParent:false,booted:false,buildNode:function(_a,_b){
this.tree=_a;
this.depth=_b;
this.imgs=[];
for(var i=0;i<this.depth+2;i++){
var _d=document.createElement("img");
_d.style.width=this.tree.iconWidth+"px";
_d.style.height=this.tree.iconHeight+"px";
_d.src=this.tree.blankIconSrc;
_d.style.verticalAlign="middle";
this.domNode.insertBefore(_d,this.containerNode);
this.imgs.push(_d);
}
this.expandIcon=this.imgs[this.imgs.length-2];
this.childIcon=this.imgs[this.imgs.length-1];
this.labelNode=document.createElement("span");
this.labelNode.appendChild(document.createTextNode(this.title));
this.domNode.insertBefore(this.labelNode,this.containerNode);
dojo.html.addClass(this.labelNode,"dojoTreeNodeLabel");
dojo.event.connect(this.expandIcon,"onclick",this,"onTreeClick");
dojo.event.connect(this.childIcon,"onclick",this,"onIconClick");
dojo.event.connect(this.labelNode,"onclick",this,"onLabelClick");
for(var i=0;i<this.children.length;i++){
this.children[i].isFirstNode=(i==0)?true:false;
this.children[i].isLastNode=(i==this.children.length-1)?true:false;
this.children[i].parentNode=this;
var _e=this.children[i].buildNode(this.tree,this.depth+1);
this.containerNode.appendChild(_e);
}
this.isParent=(this.children.length>0)?true:false;
this.collapse();
return this.domNode;
},onTreeClick:function(e){
if(this.isExpanded){
this.collapse();
}else{
this.expand();
}
},onIconClick:function(){
this.onLabelClick();
},onLabelClick:function(){
if(this.tree.selectedNode==this){
dojo.debug("TODO: start inline edit here!");
return;
}
if(this.tree.selectedNode){
this.tree.selectedNode.deselect();
}
this.tree.selectedNode=this;
this.tree.selectedNode.select();
},select:function(){
dojo.html.addClass(this.labelNode,"dojoTreeNodeLabelSelected");
dojo.event.topic.publish(this.tree.publishSelectionTopic,this.widgetId);
},deselect:function(){
dojo.html.removeClass(this.labelNode,"dojoTreeNodeLabelSelected");
},updateIcons:function(){
this.imgs[0].style.display=this.tree.showRootGrid?"inline":"none";
if(this.isParent){
this.expandIcon.src=this.isExpanded?this.tree.expandIconSrcMinus:this.tree.expandIconSrcPlus;
}else{
this.expandIcon.src=this.tree.blankIconSrc;
}
if(this.tree.showGrid){
if(this.depth){
this.setGridImage(-2,this.isLastNode?this.tree.gridIconSrcL:this.tree.gridIconSrcT);
}else{
if(this.isFirstNode){
this.setGridImage(-2,this.isLastNode?this.tree.gridIconSrcX:this.tree.gridIconSrcY);
}else{
this.setGridImage(-2,this.isLastNode?this.tree.gridIconSrcL:this.tree.gridIconSrcT);
}
}
}else{
this.setGridImage(-2,this.tree.blankIconSrc);
}
if(this.childIconSrc){
this.childIcon.style.display="inline";
this.childIcon.src=this.childIconSrc;
}else{
this.childIcon.style.display="none";
}
if((this.depth||this.tree.showRootGrid)&&this.tree.showGrid){
this.setGridImage(-1,(this.isParent&&this.isExpanded)?this.tree.gridIconSrcP:this.tree.gridIconSrcC);
}else{
if(this.tree.showGrid&&!this.tree.showRootGrid){
this.setGridImage(-1,(this.isParent&&this.isExpanded)?this.tree.gridIconSrcZ:this.tree.blankIconSrc);
}else{
this.setGridImage(-1,this.tree.blankIconSrc);
}
}
var _10=this.parentNode;
for(var i=0;i<this.depth;i++){
var idx=this.imgs.length-(3+i);
this.setGridImage(idx,(this.tree.showGrid&&!_10.isLastNode)?this.tree.gridIconSrcV:this.tree.blankIconSrc);
_10=_10.parentNode;
}
},setGridImage:function(idx,src){
if(idx<0){
idx=this.imgs.length+idx;
}
this.imgs[idx].style.backgroundImage="url("+src+")";
},updateIconTree:function(){
this.updateIcons();
for(var i=0;i<this.children.length;i++){
this.children[i].updateIconTree();
}
},expand:function(){
this.showChildren();
this.isExpanded=true;
this.updateIcons();
},collapse:function(){
this.hideChildren();
this.isExpanded=false;
this.updateIcons();
},hideChildren:function(){
if(this.booted){
this.tree.toggler.hide(this.containerNode);
}else{
this.containerNode.style.display="none";
}
dojo.event.topic.publish(this.tree.publishCollapsedTopic,this.widgetId);
},showChildren:function(){
if(this.booted){
this.tree.toggler.show(this.containerNode);
}else{
this.containerNode.style.display="block";
}
dojo.event.topic.publish(this.tree.publishExpandedTopic,this.widgetId);
},startMe:function(){
this.booted=true;
for(var i=0;i<this.children.length;i++){
this.children[i].startMe();
}
},addChild:function(_17){
this.tree.addChild.call(this,_17);
}});
dojo.widget.Tree.DefaultToggle=function(){
this.show=function(_18){
_18.style.display="block";
};
this.hide=function(_19){
_19.style.display="none";
};
};
dojo.widget.Tree.FadeToggle=function(_1a){
this.toggleDuration=_1a?_1a:150;
this.show=function(_1b){
_1b.style.display="block";
dojo.fx.html.fade(_1b,this.toggleDuration,0,1);
};
this.hide=function(_1c){
dojo.fx.html.fadeOut(_1c,this.toggleDuration,function(_1d){
_1d.style.display="none";
});
};
};
dojo.widget.Tree.WipeToggle=function(_1e){
this.toggleDuration=_1e?_1e:150;
this.show=function(_1f){
_1f.style.display="block";
dojo.fx.html.wipeIn(_1f,this.toggleDuration);
};
this.hide=function(_20){
dojo.fx.html.wipeOut(_20,this.toggleDuration,function(_21){
_21.style.display="none";
});
};
};

