dojo.provide("dojo.widget.Wizard");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.LayoutPane");
dojo.require("dojo.event.*");
dojo.require("dojo.html");
dojo.require("dojo.style");
dojo.widget.Wizard=function(){
dojo.widget.html.LayoutPane.call(this);
};
dojo.inherits(dojo.widget.Wizard,dojo.widget.html.LayoutPane);
dojo.lang.extend(dojo.widget.Wizard,{widgetType:"Wizard",labelPosition:"top",templatePath:dojo.uri.dojoUri("src/widget/templates/Wizard.html"),templateCssPath:dojo.uri.dojoUri("src/widget/templates/Wizard.css"),selected:null,wizardNode:null,wizardPanelContainerNode:null,wizardControlContainerNode:null,previousButton:null,nextButton:null,cancelButton:null,doneButton:null,nextButtonLabel:"next",previousButtonLabel:"previous",cancelButtonLabel:"cancel",doneButtonLabel:"done",cancelFunction:"",hideDisabledButtons:false,fillInTemplate:function(_1,_2){
dojo.event.connect(this.nextButton,"onclick",this,"nextPanel");
dojo.event.connect(this.previousButton,"onclick",this,"previousPanel");
if(this.cancelFunction){
dojo.event.connect(this.cancelButton,"onclick",this.cancelFunction);
}else{
this.cancelButton.style.display="none";
}
dojo.event.connect(this.doneButton,"onclick",this,"done");
this.nextButton.value=this.nextButtonLabel;
this.previousButton.value=this.previousButtonLabel;
this.cancelButton.value=this.cancelButtonLabel;
this.doneButton.value=this.doneButtonLabel;
},checkButtons:function(){
var _3=!this.hasNextPanel();
this.nextButton.disabled=_3;
this.setButtonClass(this.nextButton);
if(this.selected.doneFunction){
this.doneButton.style.display="";
if(_3){
this.nextButton.style.display="none";
}
}else{
this.doneButton.style.display="none";
}
this.previousButton.disabled=((!this.hasPreviousPanel())||(!this.selected.canGoBack));
this.setButtonClass(this.previousButton);
},setButtonClass:function(_4){
if(!this.hideDisabledButtons){
_4.style.display="";
dojo.html.setClass(_4,_4.disabled?"WizardButtonDisabled":"WizardButton");
}else{
_4.style.display=_4.disabled?"none":"";
}
},registerChild:function(_5,_6){
dojo.widget.Wizard.superclass.registerChild.call(this,_5,_6);
this.wizardPanelContainerNode.appendChild(_5.domNode);
_5.hide();
if(!this.selected){
this.onSelected(_5);
}
this.checkButtons();
},onSelected:function(_7){
if(this.selected){
if(this.selected.checkPass()){
this.selected.hide();
}else{
return;
}
}
_7.show();
this.selected=_7;
},getPanels:function(){
return this.getChildrenOfType("WizardPane",false);
},selectedIndex:function(){
if(this.selected){
return dojo.lang.indexOf(this.getPanels(),this.selected);
}
return -1;
},nextPanel:function(){
var _8=this.selectedIndex();
if(_8>-1){
var _9=this.getPanels();
if(_9[_8+1]){
this.onSelected(_9[_8+1]);
}
}
this.checkButtons();
},previousPanel:function(){
var _a=this.selectedIndex();
if(_a>-1){
var _b=this.getPanels();
if(_b[_a-1]){
this.onSelected(_b[_a-1]);
}
}
this.checkButtons();
},hasNextPanel:function(){
var _c=this.selectedIndex();
return (_c<(this.getPanels().length-1));
},hasPreviousPanel:function(){
var _d=this.selectedIndex();
return (_d>0);
},done:function(){
this.selected.done();
}});
dojo.widget.tags.addParseTreeHandler("dojo:Wizard");
dojo.widget.WizardPane=function(){
dojo.widget.html.LayoutPane.call(this);
};
dojo.inherits(dojo.widget.WizardPane,dojo.widget.html.LayoutPane);
dojo.lang.extend(dojo.widget.WizardPane,{widgetType:"WizardPane",canGoBack:true,passFunction:"",doneFunction:"",fillInTemplate:function(_e,_f){
if(this.passFunction){
this.passFunction=dj_global[this.passFunction];
}
if(this.doneFunction){
this.doneFunction=dj_global[this.doneFunction];
}
},checkPass:function(){
if(this.passFunction&&dojo.lang.isFunction(this.passFunction)){
var _10=this.passFunction();
if(_10){
alert(_10);
return false;
}
}
return true;
},done:function(){
if(this.doneFunction&&dojo.lang.isFunction(this.doneFunction)){
this.doneFunction();
}
}});
dojo.widget.tags.addParseTreeHandler("dojo:WizardPane");

