dojo.provide("dojo.widget.svg.Chart");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.widget.Chart");
dojo.require("dojo.math");
dojo.require("dojo.html");
dojo.require("dojo.svg");
dojo.require("dojo.graphics.color");
dojo.widget.svg.Chart=function(){
dojo.widget.Chart.call(this);
dojo.widget.HtmlWidget.call(this);
};
dojo.inherits(dojo.widget.svg.Chart,dojo.widget.HtmlWidget);
dojo.lang.extend(dojo.widget.svg.Chart,{templatePath:null,templateCssPath:null,_isInitialized:false,hasData:false,vectorNode:null,plotArea:null,dataGroup:null,axisGroup:null,properties:{height:400,width:600,plotType:null,padding:{top:10,bottom:2,left:60,right:30},axes:{x:{plotAt:0,label:"",unitLabel:"",unitType:Number,nUnitsToShow:10,range:{min:0,max:200}},y:{plotAt:0,label:"",unitLabel:"",unitType:Number,nUnitsToShow:10,range:{min:0,max:200}}}},fillInTemplate:function(_1,_2){
this.parseData();
this.initialize();
this.render();
},parseData:function(){
},initialize:function(){
var _3=this.domNode.getElementsByTagName("table")[0];
if(!_3){
return;
}
var _4=false;
var _5=false;
if(_3.getAttribute("width")){
this.properties.width=_3.getAttribute("width");
}
if(_3.getAttribute("height")){
this.properties.height=_3.getAttribute("height");
}
if(_3.getAttribute("plotType")){
this.properties.plotType=_3.getAttribute("plotType");
}
if(_3.getAttribute("padding")){
if(_3.getAttribute("padding").indexOf(",")>-1){
var p=_3.getAttribute("padding").split(",");
}else{
var p=_3.getAttribute("padding").split(" ");
}
if(p.length==1){
var _7=parseFloat(p[0]);
this.properties.padding.top=_7;
this.properties.padding.right=_7;
this.properties.padding.bottom=_7;
this.properties.padding.left=_7;
}else{
if(p.length==2){
var _8=parseFloat(p[0]);
var _9=parseFloat(p[1]);
this.properties.padding.top=_8;
this.properties.padding.right=_9;
this.properties.padding.bottom=_8;
this.properties.padding.left=_9;
}else{
if(p.length==4){
this.properties.padding.top=parseFloat(p[0]);
this.properties.padding.right=parseFloat(p[1]);
this.properties.padding.bottom=parseFloat(p[2]);
this.properties.padding.left=parseFloat(p[3]);
}
}
}
}
if(_3.getAttribute("rangeX")){
var p=_3.getAttribute("rangeX");
if(p.indexOf(",")>-1){
p=p.split(",");
}else{
p=p.split(" ");
}
this.properties.axes.x.range.min=parseFloat(p[0]);
this.properties.axes.x.range.max=parseFloat(p[1]);
_4=true;
}
if(_3.getAttribute("rangeY")){
var p=_3.getAttribute("rangeY");
if(p.indexOf(",")>-1){
p=p.split(",");
}else{
p=p.split(" ");
}
this.properties.axes.y.range.min=parseFloat(p[0]);
this.properties.axes.y.range.max=parseFloat(p[1]);
_5=true;
}
var _a=_3.getElementsByTagName("thead")[0];
var _b=_3.getElementsByTagName("tbody")[0];
if(!(_a&&_b)){
dojo.raise("dojo.widget.Chart: supplied table must define a head and a body.");
}
var _c=_a.getElementsByTagName("tr")[0].getElementsByTagName("th");
for(var i=1;i<_c.length;i++){
var _e="column"+i;
var _f=_c[i].innerHTML;
var _10=_c[i].getAttribute("plotType")||"line";
var _11=_c[i].getAttribute("color");
var ds=new dojo.widget.Chart.DataSeries(_e,_f,_10,_11);
this.series.push(ds);
}
var _13=_b.getElementsByTagName("tr");
var _14=Number.MAX_VALUE,xMax=Number.MIN_VALUE;
var _15=Number.MAX_VALUE,yMax=Number.MIN_VALUE;
var _16=["accesskey","align","bgcolor","class","colspan","height","id","nowrap","rowspan","style","tabindex","title","valign","width"];
for(var i=0;i<_13.length;i++){
var row=_13[i];
var _18=row.getElementsByTagName("td");
var x=Number.MIN_VALUE;
for(var j=0;j<_18.length;j++){
if(j==0){
x=parseFloat(_18[j].innerHTML);
_14=Math.min(_14,x);
xMax=Math.max(xMax,x);
}else{
var ds=this.series[j-1];
var y=parseFloat(_18[j].innerHTML);
_15=Math.min(_15,y);
yMax=Math.max(yMax,y);
var o={x:x,value:y};
var _1d=_18[j].attributes;
for(var k=0;k<_1d.length;k++){
var _1f=_1d.item(k);
var _20=false;
for(var l=0;l<_16.length;l++){
if(_1f.nodeName.toLowerCase()==_16[l]){
_20=true;
break;
}
}
if(!_20){
o[_1f.nodeName]=_1f.nodeValue;
}
}
ds.add(o);
}
}
}
if(!_4){
this.properties.axes.x.range={min:_14,max:xMax};
}
if(!_5){
this.properties.axes.y.range={min:_15,max:yMax};
}
if(_3.getAttribute("axisAt")){
var p=_3.getAttribute("axisAt");
if(p.indexOf(",")>-1){
p=p.split(",");
}else{
p=p.split(" ");
}
if(!isNaN(parseFloat(p[0]))){
this.properties.axes.x.plotAt=parseFloat(p[0]);
}else{
if(p[0].toLowerCase()=="ymin"){
this.properties.axes.x.plotAt=this.properties.axes.y.range.min;
}else{
if(p[0].toLowerCase()=="ymax"){
this.properties.axes.x.plotAt=this.properties.axes.y.range.max;
}
}
}
if(!isNaN(parseFloat(p[1]))){
this.properties.axes.y.plotAt=parseFloat(p[1]);
}else{
if(p[1].toLowerCase()=="xmin"){
this.properties.axes.y.plotAt=this.properties.axes.x.range.min;
}else{
if(p[1].toLowerCase()=="xmax"){
this.properties.axes.y.plotAt=this.properties.axes.x.range.max;
}
}
}
}else{
this.properties.axes.x.plotAt=this.properties.axes.y.range.min;
this.properties.axes.y.plotAt=this.properties.axes.x.range.min;
}
this.domNode.removeChild(_3);
dojo.svg.g.suspend();
if(this.vectorNode){
this.destroy();
}
this.vectorNode=document.createElementNS(dojo.svg.xmlns.svg,"svg");
this.vectorNode.setAttribute("width",this.properties.width);
this.vectorNode.setAttribute("height",this.properties.height);
var _22=document.createElementNS(dojo.svg.xmlns.svg,"defs");
var _23=document.createElementNS(dojo.svg.xmlns.svg,"clipPath");
_23.setAttribute("id","plotClip"+this.widgetId);
var _24=document.createElementNS(dojo.svg.xmlns.svg,"rect");
_24.setAttribute("x",this.properties.padding.left);
_24.setAttribute("y",this.properties.padding.top);
_24.setAttribute("width",this.properties.width-this.properties.padding.left-this.properties.padding.right);
_24.setAttribute("height",this.properties.height-this.properties.padding.bottom-this.properties.padding.bottom);
_23.appendChild(_24);
_22.appendChild(_23);
this.vectorNode.appendChild(_22);
this.plotArea=document.createElementNS(dojo.svg.xmlns.svg,"g");
this.vectorNode.appendChild(this.plotArea);
var _24=document.createElementNS(dojo.svg.xmlns.svg,"rect");
_24.setAttribute("x",this.properties.padding.left);
_24.setAttribute("y",this.properties.padding.top);
_24.setAttribute("width",this.properties.width-this.properties.padding.left-this.properties.padding.right);
_24.setAttribute("height",this.properties.height-this.properties.padding.bottom-this.properties.padding.bottom);
_24.setAttribute("fill","#fff");
this.plotArea.appendChild(_24);
this.dataGroup=document.createElementNS(dojo.svg.xmlns.svg,"g");
this.dataGroup.setAttribute("style","clip-path:url(#plotClip"+this.widgetId+");");
this.plotArea.appendChild(this.dataGroup);
this.axisGroup=document.createElementNS(dojo.svg.xmlns.svg,"g");
this.plotArea.appendChild(this.axisGroup);
var _25=1;
var _26=document.createElementNS(dojo.svg.xmlns.svg,"line");
var y=dojo.widget.svg.Chart.Plotter.getY(this.properties.axes.x.plotAt,this);
_26.setAttribute("y1",y);
_26.setAttribute("y2",y);
_26.setAttribute("x1",this.properties.padding.left-_25);
_26.setAttribute("x2",this.properties.width-this.properties.padding.right);
_26.setAttribute("style","stroke:#000;stroke-width:"+_25+";");
this.axisGroup.appendChild(_26);
var _27=10;
var _28=document.createElementNS(dojo.svg.xmlns.svg,"text");
_28.setAttribute("x",this.properties.padding.left);
_28.setAttribute("y",this.properties.height-this.properties.padding.bottom+_27+2);
_28.setAttribute("style","text-anchor:middle;font-size:"+_27+"px;fill:#000;");
_28.appendChild(document.createTextNode(dojo.math.round(parseFloat(this.properties.axes.x.range.min)),2));
this.axisGroup.appendChild(_28);
var _28=document.createElementNS(dojo.svg.xmlns.svg,"text");
_28.setAttribute("x",this.properties.width-this.properties.padding.right-(_27/2));
_28.setAttribute("y",this.properties.height-this.properties.padding.bottom+_27+2);
_28.setAttribute("style","text-anchor:middle;font-size:"+_27+"px;fill:#000;");
_28.appendChild(document.createTextNode(dojo.math.round(parseFloat(this.properties.axes.x.range.max)),2));
this.axisGroup.appendChild(_28);
var _26=document.createElementNS(dojo.svg.xmlns.svg,"line");
var x=dojo.widget.svg.Chart.Plotter.getX(this.properties.axes.y.plotAt,this);
_26.setAttribute("x1",x);
_26.setAttribute("x2",x);
_26.setAttribute("y1",this.properties.padding.top);
_26.setAttribute("y2",this.properties.height-this.properties.padding.bottom);
_26.setAttribute("style","stroke:#000;stroke-width:"+_25+";");
this.axisGroup.appendChild(_26);
var _28=document.createElementNS(dojo.svg.xmlns.svg,"text");
_28.setAttribute("x",this.properties.padding.left-4);
_28.setAttribute("y",this.properties.height-this.properties.padding.bottom);
_28.setAttribute("style","text-anchor:end;font-size:"+_27+"px;fill:#000;");
_28.appendChild(document.createTextNode(dojo.math.round(parseFloat(this.properties.axes.y.range.min)),2));
this.axisGroup.appendChild(_28);
var _28=document.createElementNS(dojo.svg.xmlns.svg,"text");
_28.setAttribute("x",this.properties.padding.left-4);
_28.setAttribute("y",this.properties.padding.top+(_27/2));
_28.setAttribute("style","text-anchor:end;font-size:"+_27+"px;fill:#000;");
_28.appendChild(document.createTextNode(dojo.math.round(parseFloat(this.properties.axes.y.range.max)),2));
this.axisGroup.appendChild(_28);
this.domNode.appendChild(this.vectorNode);
dojo.svg.g.resume();
this.assignColors();
this._isInitialized=true;
},destroy:function(){
while(this.domNode.childNodes.length>0){
this.domNode.removeChild(this.domNode.childNodes.item(0));
}
this.vectorNode=this.plotArea=this.dataGroup=this.axisGroup=null;
},render:function(){
dojo.svg.g.suspend();
if(this.dataGroup){
while(this.dataGroup.childNodes.length>0){
this.dataGroup.removeChild(this.dataGroup.childNodes.item(0));
}
}else{
this.initialize();
}
for(var i=0;i<this.series.length;i++){
dojo.widget.svg.Chart.Plotter.plot(this.series[i],this);
}
dojo.svg.g.resume();
}});
dojo.widget.svg.Chart.PlotTypes={Bar:"bar",Line:"line",Scatter:"scatter",Bubble:"bubble"};
dojo.widget.svg.Chart.Plotter=new function(){
var _2a=this;
var _2b={};
var _2c=dojo.widget.svg.Chart.PlotTypes;
this.getX=function(_2d,_2e){
var v=parseFloat(_2d);
var min=_2e.properties.axes.x.range.min;
var max=_2e.properties.axes.x.range.max;
var _32=0-min;
min+=_32;
max+=_32;
v+=_32;
var _33=_2e.properties.padding.left;
var _34=_2e.properties.width-_2e.properties.padding.right;
var x=(v*((_34-_33)/max))+_33;
return x;
};
this.getY=function(_36,_37){
var v=parseFloat(_36);
var max=_37.properties.axes.y.range.max;
var min=_37.properties.axes.y.range.min;
var _3b=0;
if(min<0){
_3b+=Math.abs(min);
}
min+=_3b;
max+=_3b;
v+=_3b;
var _3c=_37.properties.height-_37.properties.padding.bottom;
var _3d=_37.properties.padding.top;
var y=(((_3c-_3d)/(max-min))*(max-v))+_3d;
return y;
};
this.addPlotter=function(_3f,_40){
_2b[_3f]=_40;
};
this.plot=function(_41,_42){
if(_41.values.length==0){
return;
}
if(_41.plotType&&_2b[_41.plotType]){
return _2b[_41.plotType](_41,_42);
}else{
if(_42.plotType&&_2b[_42.plotType]){
return _2b[_42.plotType](_41,_42);
}
}
};
_2b[_2c.Bar]=function(_43,_44){
var _45=1;
var _46=0;
for(var i=0;i<_43.values.length;i++){
var x=_2a.getX(_43.values[i].x,_44);
var w;
if(i==_43.values.length-1){
w=_46;
}else{
w=_2a.getX(_43.values[i+1].x,_44)-x-_45;
_46=w;
}
x-=(w/2);
var yA=_2a.getY(_44.properties.axes.x.plotAt,_44);
var y=_2a.getY(_43.values[i].value,_44);
var h=Math.abs(yA-y);
if(parseFloat(_43.values[i].value)<_44.properties.axes.x.plotAt){
var oy=yA;
yA=y;
y=oy;
}
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",_43.color);
bar.setAttribute("title",_43.label+": "+_43.values[i].value);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.9");
_44.dataGroup.appendChild(bar);
}
};
_2b[_2c.Line]=function(_4f,_50){
var _51=3;
var _52=document.createElementNS(dojo.svg.xmlns.svg,"path");
_52.setAttribute("fill","none");
_52.setAttribute("stroke",_4f.color);
_52.setAttribute("stroke-width","1.5");
_52.setAttribute("stroke-opacity","0.85");
_52.setAttribute("title",_4f.label);
_50.dataGroup.appendChild(_52);
var _53=[];
for(var i=0;i<_4f.values.length;i++){
var x=_2a.getX(_4f.values[i].x,_50);
var y=_2a.getY(_4f.values[i].value,_50);
var dx=_50.properties.padding.left+1;
var dy=_50.properties.height-_50.properties.padding.bottom;
if(i>0){
dx=x-_2a.getX(_4f.values[i-1].x,_50);
dy=_2a.getY(_4f.values[i-1].value,_50);
}
if(i==0){
_53.push("M");
}else{
_53.push("C");
var cx=x-(_51-1)*(dx/_51);
_53.push(cx+","+dy);
cx=x-(dx/_51);
_53.push(cx+","+y);
}
_53.push(x+","+y);
}
_52.setAttribute("d",_53.join(" "));
};
_2b[_2c.Scatter]=function(_5a,_5b){
var r=7;
for(var i=0;i<_5a.values.length;i++){
var x=_2a.getX(_5a.values[i].x,_5b);
var y=_2a.getY(_5a.values[i].value,_5b);
var _60=document.createElementNS(dojo.svg.xmlns.svg,"path");
_60.setAttribute("fill",_5a.color);
_60.setAttribute("stroke-width","0");
_60.setAttribute("title",_5a.label+": "+_5a.values[i].value);
_60.setAttribute("d","M "+x+","+(y-r)+" "+"Q "+x+","+y+" "+(x+r)+","+y+" "+"Q "+x+","+y+" "+x+","+(y+r)+" "+"Q "+x+","+y+" "+(x-r)+","+y+" "+"Q "+x+","+y+" "+x+","+(y-r)+" "+"Z");
_5b.dataGroup.appendChild(_60);
}
};
_2b[_2c.Bubble]=function(_61,_62){
var _63=1;
var min=_62.properties.axes.x.range.min;
var max=_62.properties.axes.x.range.max;
var _66=0-min;
min+=_66;
max+=_66;
v+=_66;
var _67=_62.properties.padding.left;
var _68=_62.properties.width-_62.properties.padding.right;
var _69=(max-min)/(_68-_67)*25;
for(var i=0;i<_61.values.length;i++){
var _6b=_61.values[i].size;
if(isNaN(parseFloat(_6b))){
_6b=_63;
}
var _6c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
_6c.setAttribute("stroke-width",0);
_6c.setAttribute("fill",_61.color);
_6c.setAttribute("fill-opacity","0.8");
_6c.setAttribute("r",(parseFloat(_6b)*_69)/2);
_6c.setAttribute("cx",_2a.getX(_61.values[i].x,_62));
_6c.setAttribute("cy",_2a.getY(_61.values[i].value,_62));
_6c.setAttribute("title",_61.label+": "+_61.values[i].value+" ("+_6b+")");
_62.dataGroup.appendChild(_6c);
}
};
}();

