dojo.provide("dojo.collections.BinaryTree");
dojo.require("dojo.collections.Collections");
dojo.collections.BinaryTree=function(_1){
function node(_2,_3,_4){
this.value=_2||null;
this.right=_3||null;
this.left=_4||null;
this.clone=function(){
var c=new node();
if(this.value.value){
c.value=this.value.clone();
}else{
c.value=this.value;
}
if(this.left){
c.left=this.left.clone();
}
if(this.right){
c.right=this.right.clone();
}
};
this.compare=function(n){
if(this.value>n.value){
return 1;
}
if(this.value<n.value){
return -1;
}
return 0;
};
this.compareData=function(d){
if(this.value>d){
return 1;
}
if(this.value<d){
return -1;
}
return 0;
};
}
function inorderTraversalBuildup(_8,a){
if(_8){
inorderTraversalBuildup(_8.left,a);
a.add(_8);
inorderTraversalBuildup(_8.right,a);
}
}
function preorderTraversal(_a,_b){
var s="";
if(_a){
s=_a.value.toString()+_b;
s+=preorderTraversal(_a.left,_b);
s+=preorderTraversal(_a.right,_b);
}
return s;
}
function inorderTraversal(_d,_e){
var s="";
if(_d){
s=inorderTraversal(_d.left,_e);
s+=_d.value.toString()+_e;
s+=inorderTraversal(_d.right,_e);
}
return s;
}
function postorderTraversal(_10,sep){
var s="";
if(_10){
s=postorderTraversal(_10.left,sep);
s+=postorderTraversal(_10.right,sep);
s+=_10.value.toString()+sep;
}
return s;
}
function searchHelper(_13,_14){
if(!_13){
return null;
}
var i=_13.compareData(_14);
if(i==0){
return _13;
}
if(result>0){
return searchHelper(_13.left,_14);
}else{
return searchHelper(_13.right,_14);
}
}
this.add=function(_16){
var n=new node(_16);
var i;
var _19=root;
var _1a=null;
while(_19){
i=_19.compare(n);
if(i==0){
return;
}
_1a=_19;
if(i>0){
_19=_19.left;
}else{
_19=_19.right;
}
}
this.count++;
if(!_1a){
root=n;
}else{
i=_1a.compare(n);
if(i>0){
_1a.left=n;
}else{
_1a.right=n;
}
}
};
this.clear=function(){
root=null;
this.count=0;
};
this.clone=function(){
var c=new dojo.collections.BinaryTree();
c.root=root.clone();
c.count=this.count;
return c;
};
this.contains=function(_1c){
return this.search(_1c)!=null;
};
this.deleteData=function(_1d){
var _1e=root;
var _1f=null;
var i=_1e.compareData(_1d);
while(i!=0&&_1e!=null){
if(i>0){
_1f=_1e;
_1e=_1e.left;
}else{
if(i<0){
_1f=_1e;
_1e=_1e.right;
}
}
i=_1e.compareData(_1d);
}
if(!_1e){
return;
}
this.count--;
if(!_1e.right){
if(!_1f){
root=_1e.left;
}else{
i=_1f.compare(_1e);
if(i>0){
_1f.left=_1e.left;
}else{
if(i<0){
_1f.right=_1e.left;
}
}
}
}else{
if(!_1e.right.left){
if(!_1f){
root=_1e.right;
}else{
i=_1f.compare(_1e);
if(i>0){
_1f.left=_1e.right;
}else{
if(i<0){
_1f.right=_1e.right;
}
}
}
}else{
var _21=_1e.right.left;
var _22=_1e.right;
while(_21.left!=null){
_22=_21;
_21=_21.left;
}
_22.left=_21.right;
_21.left=_1e.left;
_21.right=_1e.right;
if(!_1f){
root=_21;
}else{
i=_1f.compare(_1e);
if(i>0){
_1f.left=_21;
}else{
if(i<0){
_1f.right=_21;
}
}
}
}
}
};
this.getIterator=function(){
var a=new ArrayList();
inorderTraversalBuildup(root,a);
return a.getIterator();
};
this.search=function(_24){
return searchHelper(root,_24);
};
this.toString=function(_25,sep){
if(!_25){
var _25=dojo.collections.BinaryTree.TraversalMethods.Inorder;
}
if(!sep){
var sep=" ";
}
var s="";
switch(_25){
case dojo.collections.BinaryTree.TraversalMethods.Preorder:
s=preorderTraversal(root,sep);
break;
case dojo.collections.BinaryTree.TraversalMethods.Inorder:
s=inorderTraversal(root,sep);
break;
case dojo.collections.BinaryTree.TraversalMethods.Postorder:
s=postorderTraversal(root,sep);
break;
}
if(s.length==0){
return "";
}else{
return s.substring(0,s.length-sep.length);
}
};
this.count=0;
var _28=this.root=null;
if(_1){
this.add(_1);
}
};
dojo.collections.BinaryTree.TraversalMethods={Preorder:0,Inorder:1,Postorder:2};

