dojo.provide("dojo.collections.Graph");
dojo.require("dojo.collections.Collections");
dojo.collections.Graph=function(_1){
function node(_2,_3,_4){
this.key=_2;
this.data=_3;
this.neighbors=_4||new adjacencyList();
this.addDirected=function(){
if(arguments[0].constructor==edgeToNeighbor){
this.neighbors.add(arguments[0]);
}else{
var n=arguments[0];
var _6=arguments[1]||0;
this.neighbors.add(new edgeToNeighbor(n,_6));
}
};
}
function nodeList(){
var d=new dojo.collections.Dictionary();
function nodelistiterator(){
var o=[];
var e=d.getIterator();
while(e.moveNext()){
o[o.length]=e.current;
}
var _a=0;
this.current=null;
this.entry=null;
this.key=null;
this.value=null;
this.atEnd=false;
this.moveNext=function(){
if(this.atEnd){
return !this.atEnd;
}
this.entry=this.current=o[_a];
if(this.entry){
this.key=this.entry.key;
this.value=this.entry.data;
}
if(_a==o.length){
this.atEnd=true;
}
_a++;
return !this.atEnd;
};
this.reset=function(){
_a=0;
this.atEnd=false;
};
}
this.add=function(_b){
d.add(_b.key,_b);
};
this.clear=function(){
d.clear();
};
this.containsKey=function(_c){
return d.containsKey(_c);
};
this.getIterator=function(){
return new nodelistiterator(this);
};
this.item=function(_d){
return d.item(_d);
};
this.remove=function(_e){
d.remove(_e.key);
};
}
function edgeToNeighbor(_f,_10){
this.neighbor=_f;
this.cost=_10;
}
function adjacencyList(){
var d=[];
this.add=function(o){
d.push(o);
};
this.item=function(i){
return d[i];
};
this.getIterator=function(){
return new dojo.collections.Iterator([].concat(d));
};
}
this.nodes=_1||new nodeList();
this.count=this.nodes.count;
this.clear=function(){
this.nodes.clear();
this.count=0;
};
this.addNode=function(){
var n=arguments[0];
if(arguments.length>1){
n=new node(arguments[0],arguments[1]);
}
if(!this.nodes.containsKey(n.key)){
this.nodes.add(n);
this.count++;
}
};
this.addDirectedEdge=function(_15,_16,_17){
var _18,vNode;
if(_15.constructor!=node){
_18=this.nodes.item(_15);
vNode=this.nodes.item(_16);
}else{
_18=_15;
vNode=_16;
}
var c=_17||0;
_18.addDirected(vNode,c);
};
this.addUndirectedEdge=function(_1a,_1b,_1c){
var _1d,vNode;
if(_1a.constructor!=node){
_1d=this.nodes.item(_1a);
vNode=this.nodes.item(_1b);
}else{
_1d=_1a;
vNode=_1b;
}
var c=_1c||0;
_1d.addDirected(vNode,c);
vNode.addDirected(_1d,c);
};
this.contains=function(n){
return this.nodes.containsKey(n.key);
};
this.containsKey=function(k){
return this.nodes.containsKey(k);
};
};

