dojo.provide("dojo.collections.Set");
dojo.require("dojo.collections.Collections");
dojo.require("dojo.collections.ArrayList");
dojo.collections.Set=new function(){
this.union=function(_1,_2){
if(_1.constructor==Array){
var _1=new dojo.collections.ArrayList(_1);
}
if(_2.constructor==Array){
var _2=new dojo.collections.ArrayList(_2);
}
if(!_1.toArray||!_2.toArray){
dojo.raise("Set operations can only be performed on array-based collections.");
}
var _3=new dojo.collections.ArrayList(_1.toArray());
var e=_2.getIterator();
while(!e.atEnd){
if(!_3.contains(e.current)){
_3.add(e.current);
}
}
return _3;
};
this.intersection=function(_5,_6){
if(_5.constructor==Array){
var _5=new dojo.collections.ArrayList(_5);
}
if(_6.constructor==Array){
var _6=new dojo.collections.ArrayList(_6);
}
if(!_5.toArray||!_6.toArray){
dojo.raise("Set operations can only be performed on array-based collections.");
}
var _7=new dojo.collections.ArrayList();
var e=_6.getIterator();
while(!e.atEnd){
if(_5.contains(e.current)){
_7.add(e.current);
}
e.moveNext();
}
return _7;
};
this.difference=function(_9,_a){
if(_9.constructor==Array){
var _9=new dojo.collections.ArrayList(_9);
}
if(_a.constructor==Array){
var _a=new dojo.collections.ArrayList(_a);
}
if(!_9.toArray||!_a.toArray){
dojo.raise("Set operations can only be performed on array-based collections.");
}
var _b=new dojo.collections.ArrayList();
var e=_9.getIterator();
while(!e.atEnd){
if(!_a.contains(e.current)){
_b.add(e.current);
}
e.moveNext();
}
return _b;
};
this.isSubSet=function(_d,_e){
if(_d.constructor==Array){
var _d=new dojo.collections.ArrayList(_d);
}
if(_e.constructor==Array){
var _e=new dojo.collections.ArrayList(_e);
}
if(!_d.toArray||!_e.toArray){
dojo.raise("Set operations can only be performed on array-based collections.");
}
var e=_d.getIterator();
while(!e.atEnd){
if(!_e.contains(e.current)){
return false;
}
e.moveNext();
}
return true;
};
this.isSuperSet=function(_10,_11){
if(_10.constructor==Array){
var _10=new dojo.collections.ArrayList(_10);
}
if(_11.constructor==Array){
var _11=new dojo.collections.ArrayList(_11);
}
if(!_10.toArray||!_11.toArray){
dojo.raise("Set operations can only be performed on array-based collections.");
}
var e=_11.getIterator();
while(!e.atEnd){
if(!_10.contains(e.current)){
return false;
}
e.moveNext();
}
return true;
};
}();

