dojo.provide("dojo.dnd.HtmlDragAndDrop");
dojo.provide("dojo.dnd.HtmlDragSource");
dojo.provide("dojo.dnd.HtmlDropTarget");
dojo.provide("dojo.dnd.HtmlDragObject");
dojo.require("dojo.dnd.HtmlDragManager");
dojo.require("dojo.animation.*");
dojo.require("dojo.dom");
dojo.require("dojo.style");
dojo.require("dojo.html");
dojo.require("dojo.lang");
dojo.dnd.HtmlDragSource=function(_1,_2){
_1=dojo.byId(_1);
this.constrainToContainer=false;
if(_1){
this.domNode=_1;
this.dragObject=_1;
dojo.dnd.DragSource.call(this);
this.type=_2||this.domNode.nodeName.toLowerCase();
}
};
dojo.lang.extend(dojo.dnd.HtmlDragSource,{dragClass:"",onDragStart:function(){
var _3=new dojo.dnd.HtmlDragObject(this.dragObject,this.type,this.dragClass);
if(this.constrainToContainer){
_3.constrainTo(this.constrainingContainer);
}
return _3;
},setDragHandle:function(_4){
_4=dojo.byId(_4);
dojo.dnd.dragManager.unregisterDragSource(this);
this.domNode=_4;
dojo.dnd.dragManager.registerDragSource(this);
},setDragTarget:function(_5){
this.dragObject=_5;
},constrainTo:function(_6){
this.constrainToContainer=true;
if(_6){
this.constrainingContainer=_6;
}else{
this.constrainingContainer=this.domNode.parentNode;
}
}});
dojo.dnd.HtmlDragObject=function(_7,_8,_9){
this.domNode=dojo.byId(_7);
this.type=_8;
if(_9){
this.dragClass=_9;
}
this.constrainToContainer=false;
};
dojo.lang.extend(dojo.dnd.HtmlDragObject,{dragClass:"",opacity:0.5,disableX:false,disableY:false,onDragStart:function(e){
dojo.html.clearSelection();
this.scrollOffset={top:dojo.html.getScrollTop(),left:dojo.html.getScrollLeft()};
this.dragStartPosition={top:dojo.style.getAbsoluteY(this.domNode,true)+this.scrollOffset.top,left:dojo.style.getAbsoluteX(this.domNode,true)+this.scrollOffset.left};
this.dragOffset={top:this.dragStartPosition.top-e.clientY,left:this.dragStartPosition.left-e.clientX};
this.dragClone=this.domNode.cloneNode(true);
if((this.domNode.parentNode.nodeName.toLowerCase()=="body")||(dojo.style.getComputedStyle(this.domNode.parentNode,"position")=="static")){
this.parentPosition={top:0,left:0};
}else{
this.parentPosition={top:dojo.style.getAbsoluteY(this.domNode.parentNode,true),left:dojo.style.getAbsoluteX(this.domNode.parentNode,true)};
}
if(this.constrainToContainer){
this.constraints=this.getConstraints();
}
with(this.dragClone.style){
position="absolute";
top=this.dragOffset.top+e.clientY+"px";
left=this.dragOffset.left+e.clientX+"px";
}
if(this.dragClass){
dojo.html.addClass(this.dragClone,this.dragClass);
}
dojo.style.setOpacity(this.dragClone,this.opacity);
dojo.html.body().appendChild(this.dragClone);
},getConstraints:function(){
if(this.constrainingContainer.nodeName.toLowerCase()=="body"){
width=dojo.html.getViewportWidth();
height=dojo.html.getViewportHeight();
padLeft=0;
padTop=0;
}else{
width=dojo.style.getContentWidth(this.constrainingContainer);
height=dojo.style.getContentHeight(this.constrainingContainer);
padLeft=dojo.style.getPixelValue(this.constrainingContainer,"padding-left",true);
padTop=dojo.style.getPixelValue(this.constrainingContainer,"padding-top",true);
}
return {minX:padLeft,minY:padTop,maxX:padLeft+width-dojo.style.getOuterWidth(this.domNode),maxY:padTop+height-dojo.style.getOuterHeight(this.domNode)};
},updateDragOffset:function(){
var _b=dojo.html.getScrollTop();
var _c=dojo.html.getScrollLeft();
if(_b!=this.scrollOffset.top){
var _d=_b-this.scrollOffset.top;
this.dragOffset.top+=_d;
this.scrollOffset.top=_b;
}
},onDragMove:function(e){
this.updateDragOffset();
var x=this.dragOffset.left+e.clientX-this.parentPosition.left;
var y=this.dragOffset.top+e.clientY-this.parentPosition.top;
if(this.constrainToContainer){
if(x<this.constraints.minX){
x=this.constraints.minX;
}
if(y<this.constraints.minY){
y=this.constraints.minY;
}
if(x>this.constraints.maxX){
x=this.constraints.maxX;
}
if(y>this.constraints.maxY){
y=this.constraints.maxY;
}
}
if(!this.disableY){
this.dragClone.style.top=y+"px";
}
if(!this.disableX){
this.dragClone.style.left=x+"px";
}
},onDragEnd:function(e){
switch(e.dragStatus){
case "dropSuccess":
dojo.dom.removeNode(this.dragClone);
this.dragClone=null;
break;
case "dropFailure":
var _12=[dojo.style.getAbsoluteX(this.dragClone),dojo.style.getAbsoluteY(this.dragClone)];
var _13=[this.dragStartPosition.left+1,this.dragStartPosition.top+1];
var _14=new dojo.math.curves.Line(_12,_13);
var _15=new dojo.animation.Animation(_14,300,0,0);
var _16=this;
dojo.event.connect(_15,"onAnimate",function(e){
_16.dragClone.style.left=e.x+"px";
_16.dragClone.style.top=e.y+"px";
});
dojo.event.connect(_15,"onEnd",function(e){
dojo.lang.setTimeout(dojo.dom.removeNode,200,_16.dragClone);
});
_15.play();
break;
}
},constrainTo:function(_19){
this.constrainToContainer=true;
if(_19){
this.constrainingContainer=_19;
}else{
this.constrainingContainer=this.domNode.parentNode;
}
}});
dojo.dnd.HtmlDropTarget=function(_1a,_1b){
if(arguments.length==0){
return;
}
_1a=dojo.byId(_1a);
this.domNode=_1a;
dojo.dnd.DropTarget.call(this);
this.acceptedTypes=_1b||[];
};
dojo.inherits(dojo.dnd.HtmlDropTarget,dojo.dnd.DropTarget);
dojo.lang.extend(dojo.dnd.HtmlDropTarget,{onDragOver:function(e){
if(!this.accepts(e.dragObjects)){
return false;
}
this.childBoxes=[];
for(var i=0,child;i<this.domNode.childNodes.length;i++){
child=this.domNode.childNodes[i];
if(child.nodeType!=dojo.dom.ELEMENT_NODE){
continue;
}
var top=dojo.style.getAbsoluteY(child);
var _1f=top+dojo.style.getInnerHeight(child);
var _20=dojo.style.getAbsoluteX(child);
var _21=_20+dojo.style.getInnerWidth(child);
this.childBoxes.push({top:top,bottom:_1f,left:_20,right:_21,node:child});
}
return true;
},_getNodeUnderMouse:function(e){
var _23=e.pageX||e.clientX+dojo.html.body().scrollLeft;
var _24=e.pageY||e.clientY+dojo.html.body().scrollTop;
for(var i=0,child;i<this.childBoxes.length;i++){
with(this.childBoxes[i]){
if(_23>=left&&_23<=right&&_24>=top&&_24<=bottom){
return i;
}
}
}
return -1;
},createDropIndicator:function(){
this.dropIndicator=document.createElement("div");
with(this.dropIndicator.style){
position="absolute";
zIndex=1;
borderTopWidth="1px";
borderTopColor="black";
borderTopStyle="solid";
width=dojo.style.getInnerWidth(this.domNode)+"px";
left=dojo.style.getAbsoluteX(this.domNode)+"px";
}
},onDragMove:function(e,_27){
var i=this._getNodeUnderMouse(e);
if(!this.dropIndicator){
this.createDropIndicator();
}
if(i<0){
if(this.childBoxes.length){
var _29=(dojo.html.gravity(this.childBoxes[0].node,e)&dojo.html.gravity.NORTH);
}else{
var _29=true;
}
}else{
var _2a=this.childBoxes[i];
var _29=(dojo.html.gravity(_2a.node,e)&dojo.html.gravity.NORTH);
}
this.placeIndicator(e,_27,i,_29);
if(!dojo.html.hasParent(this.dropIndicator)){
dojo.html.body().appendChild(this.dropIndicator);
}
},placeIndicator:function(e,_2c,_2d,_2e){
with(this.dropIndicator.style){
if(_2d<0){
if(this.childBoxes.length){
top=(_2e?this.childBoxes[0].top:this.childBoxes[this.childBoxes.length-1].bottom)+"px";
}else{
top=dojo.style.getAbsoluteY(this.domNode)+"px";
}
}else{
var _2f=this.childBoxes[_2d];
top=(_2e?_2f.top:_2f.bottom)+"px";
}
}
},onDragOut:function(e){
dojo.dom.removeNode(this.dropIndicator);
delete this.dropIndicator;
},onDrop:function(e){
this.onDragOut(e);
var i=this._getNodeUnderMouse(e);
if(i<0){
if(this.childBoxes.length){
if(dojo.html.gravity(this.childBoxes[0].node,e)&dojo.html.gravity.NORTH){
return this.insert(e,this.childBoxes[0].node,"before");
}else{
return this.insert(e,this.childBoxes[this.childBoxes.length-1].node,"after");
}
}
return this.insert(e,this.domNode,"append");
}
var _33=this.childBoxes[i];
if(dojo.html.gravity(_33.node,e)&dojo.html.gravity.NORTH){
return this.insert(e,_33.node,"before");
}else{
return this.insert(e,_33.node,"after");
}
},insert:function(e,_35,_36){
var _37=e.dragObject.domNode;
if(_36=="before"){
return dojo.html.insertBefore(_37,_35);
}else{
if(_36=="after"){
return dojo.html.insertAfter(_37,_35);
}else{
if(_36=="append"){
_35.appendChild(_37);
return true;
}
}
}
return false;
}});

