dojo.provide("dojo.dnd.HtmlDragManager");
dojo.require("dojo.event.*");
dojo.require("dojo.lang");
dojo.require("dojo.html");
dojo.require("dojo.style");
dojo.dnd.HtmlDragManager=function(){
};
dojo.inherits(dojo.dnd.HtmlDragManager,dojo.dnd.DragManager);
dojo.lang.extend(dojo.dnd.HtmlDragManager,{disabled:false,nestedTargets:false,mouseDownTimer:null,dsCounter:0,dsPrefix:"dojoDragSource",dropTargetDimensions:[],currentDropTarget:null,currentDropTargetPoints:null,previousDropTarget:null,_dragTriggered:false,selectedSources:[],dragObjects:[],currentX:null,currentY:null,lastX:null,lastY:null,mouseDownX:null,mouseDownY:null,threshold:7,dropAcceptable:false,registerDragSource:function(ds){
if(ds["domNode"]){
var dp=this.dsPrefix;
var _3=dp+"Idx_"+(this.dsCounter++);
ds.dragSourceId=_3;
this.dragSources[_3]=ds;
ds.domNode.setAttribute(dp,_3);
}
},unregisterDragSource:function(ds){
if(ds["domNode"]){
var dp=this.dsPrefix;
var _6=ds.dragSourceId;
delete ds.dragSourceId;
delete this.dragSources[_6];
ds.domNode.setAttribute(dp,null);
}
},registerDropTarget:function(dt){
this.dropTargets.push(dt);
},getDragSource:function(e){
var tn=e.target;
if(tn===dojo.html.body()){
return;
}
var ta=dojo.html.getAttribute(tn,this.dsPrefix);
while((!ta)&&(tn)){
tn=tn.parentNode;
if((!tn)||(tn===dojo.html.body())){
return;
}
ta=dojo.html.getAttribute(tn,this.dsPrefix);
}
return this.dragSources[ta];
},onKeyDown:function(e){
},onMouseDown:function(e){
if(this.disabled){
return;
}
this.mouseDownX=e.clientX;
this.mouseDownY=e.clientY;
var _d=e.target.nodeType==dojo.dom.TEXT_NODE?e.target.parentNode:e.target;
switch(_d.tagName.toLowerCase()){
case "a":
case "button":
case "textarea":
case "input":
return;
}
var ds=this.getDragSource(e);
if(!ds){
return;
}
if(!dojo.lang.inArray(this.selectedSources,ds)){
this.selectedSources.push(ds);
}
e.preventDefault();
dojo.event.connect(document,"onmousemove",this,"onMouseMove");
},onMouseUp:function(e){
this.mouseDownX=null;
this.mouseDownY=null;
this._dragTriggered=false;
var _10=this;
e.dragSource=this.dragSource;
if((!e.shiftKey)&&(!e.ctrlKey)){
dojo.lang.forEach(this.dragObjects,function(_11){
var ret=null;
if(!_11){
return;
}
if(_10.currentDropTarget){
e.dragObject=_11;
var ce=_10.currentDropTarget.domNode.childNodes;
if(ce.length>0){
e.dropTarget=ce[0];
while(e.dropTarget==_11.domNode){
e.dropTarget=e.dropTarget.nextSibling;
}
}else{
e.dropTarget=_10.currentDropTarget.domNode;
}
if(_10.dropAcceptable){
ret=_10.currentDropTarget.onDrop(e);
}else{
_10.currentDropTarget.onDragOut(e);
}
}
e.dragStatus=_10.dropAcceptable&&ret?"dropSuccess":"dropFailure";
_11.onDragEnd(e);
});
this.selectedSources=[];
this.dragObjects=[];
this.dragSource=null;
}
dojo.event.disconnect(document,"onmousemove",this,"onMouseMove");
this.currentDropTarget=null;
this.currentDropTargetPoints=null;
},scrollBy:function(x,y){
for(var i=0;i<this.dragObjects.length;i++){
if(this.dragObjects[i].updateDragOffset){
this.dragObjects[i].updateDragOffset();
}
}
},_dragStartDistance:function(x,y){
if((!this.mouseDownX)||(!this.mouseDownX)){
return;
}
var dx=Math.abs(x-this.mouseDownX);
var dx2=dx*dx;
var dy=Math.abs(y-this.mouseDownY);
var dy2=dy*dy;
return parseInt(Math.sqrt(dx2+dy2),10);
},onMouseMove:function(e){
var _1e=this;
if((this.selectedSources.length)&&(!this.dragObjects.length)){
var dx;
var dy;
if(!this._dragTriggered){
this._dragTriggered=(this._dragStartDistance(e.clientX,e.clientY)>this.threshold);
if(!this._dragTriggered){
return;
}
dx=e.clientX-this.mouseDownX;
dy=e.clientY-this.mouseDownY;
}
if(this.selectedSources.length==1){
this.dragSource=this.selectedSources[0];
}
dojo.lang.forEach(this.selectedSources,function(_21){
if(!_21){
return;
}
var tdo=_21.onDragStart(e);
if(tdo){
tdo.onDragStart(e);
tdo.dragOffset.top+=dy;
tdo.dragOffset.left+=dx;
_1e.dragObjects.push(tdo);
}
});
this.dropTargetDimensions=[];
dojo.lang.forEach(this.dropTargets,function(_23){
var tn=_23.domNode;
if(!tn){
return;
}
var ttx=dojo.style.getAbsoluteX(tn,true);
var tty=dojo.style.getAbsoluteY(tn,true);
_1e.dropTargetDimensions.push([[ttx,tty],[ttx+dojo.style.getInnerWidth(tn),tty+dojo.style.getInnerHeight(tn)],_23]);
});
}
for(var i=0;i<this.dragObjects.length;i++){
if(this.dragObjects[i]){
this.dragObjects[i].onDragMove(e);
}
}
var dtp=this.currentDropTargetPoints;
if((!this.nestedTargets)&&(dtp)&&(this.isInsideBox(e,dtp))){
if(this.dropAcceptable){
this.currentDropTarget.onDragMove(e,this.dragObjects);
}
}else{
var _29=this.findBestTarget(e);
if(_29.target==null){
if(this.currentDropTarget){
this.currentDropTarget.onDragOut(e);
this.currentDropTarget=null;
this.currentDropTargetPoints=null;
}
this.dropAcceptable=false;
return;
}
if(this.currentDropTarget!=_29.target){
if(this.currentDropTarget){
this.currentDropTarget.onDragOut(e);
}
this.currentDropTarget=_29.target;
this.currentDropTargetPoints=_29.points;
e.dragObjects=this.dragObjects;
this.dropAcceptable=this.currentDropTarget.onDragOver(e);
}else{
if(this.dropAcceptable){
this.currentDropTarget.onDragMove(e,this.dragObjects);
}
}
}
},findBestTarget:function(e){
var _2b=this;
var _2c=new Object();
_2c.target=null;
_2c.points=null;
dojo.lang.forEach(this.dropTargetDimensions,function(_2d){
if(_2b.isInsideBox(e,_2d)){
_2c.target=_2d[2];
_2c.points=_2d;
if(!_2b.nestedTargets){
return "break";
}
}
});
return _2c;
},isInsideBox:function(e,_2f){
if((e.clientX>_2f[0][0])&&(e.clientX<_2f[1][0])&&(e.clientY>_2f[0][1])&&(e.clientY<_2f[1][1])){
return true;
}
return false;
},onMouseOver:function(e){
},onMouseOut:function(e){
}});
dojo.dnd.dragManager=new dojo.dnd.HtmlDragManager();
(function(){
var d=document;
var dm=dojo.dnd.dragManager;
dojo.event.connect(d,"onkeydown",dm,"onKeyDown");
dojo.event.connect(d,"onmouseover",dm,"onMouseOver");
dojo.event.connect(d,"onmouseout",dm,"onMouseOut");
dojo.event.connect(d,"onmousedown",dm,"onMouseDown");
dojo.event.connect(d,"onmouseup",dm,"onMouseUp");
dojo.event.connect(window,"scrollBy",dm,"scrollBy");
})();

