dojo.provide("dojo.lang");
dojo.provide("dojo.AdapterRegistry");
dojo.provide("dojo.lang.Lang");
dojo.lang.mixin=function(_1,_2){
var _3={};
for(var x in _2){
if(typeof _3[x]=="undefined"||_3[x]!=_2[x]){
_1[x]=_2[x];
}
}
if(dojo.render.html.ie&&dojo.lang.isFunction(_2["toString"])&&_2["toString"]!=_1["toString"]){
_1.toString=_2.toString;
}
return _1;
};
dojo.lang.extend=function(_5,_6){
this.mixin(_5.prototype,_6);
};
dojo.lang.extendPrototype=function(_7,_8){
this.extend(_7.constructor,_8);
};
dojo.lang.anonCtr=0;
dojo.lang.anon={};
dojo.lang.nameAnonFunc=function(_9,_a){
var _b=(_a||dojo.lang.anon);
if((dj_global["djConfig"])&&(djConfig["slowAnonFuncLookups"]==true)){
for(var x in _b){
if(_b[x]===_9){
return x;
}
}
}
var _d="__"+dojo.lang.anonCtr++;
while(typeof _b[_d]!="undefined"){
_d="__"+dojo.lang.anonCtr++;
}
_b[_d]=_9;
return _d;
};
dojo.lang.hitch=function(_e,_f){
if(dojo.lang.isString(_f)){
var fcn=_e[_f];
}else{
var fcn=_f;
}
return function(){
return fcn.apply(_e,arguments);
};
};
dojo.lang.forward=function(_11){
return function(){
return this[_11].apply(this,arguments);
};
};
dojo.lang.curry=function(ns,_13){
var _14=[];
ns=ns||dj_global;
if(dojo.lang.isString(_13)){
_13=ns[_13];
}
for(var x=2;x<arguments.length;x++){
_14.push(arguments[x]);
}
var _16=_13.length-_14.length;
function gather(_17,_18,_19){
var _1a=_19;
var _1b=_18.slice(0);
for(var x=0;x<_17.length;x++){
_1b.push(_17[x]);
}
_19=_19-_17.length;
if(_19<=0){
var res=_13.apply(ns,_1b);
_19=_1a;
return res;
}else{
return function(){
return gather(arguments,_1b,_19);
};
}
}
return gather([],_14,_16);
};
dojo.lang.curryArguments=function(ns,_1f,_20,_21){
var _22=[];
var x=_21||0;
for(x=_21;x<_20.length;x++){
_22.push(_20[x]);
}
return dojo.lang.curry.apply(dojo.lang,[ns,_1f].concat(_22));
};
dojo.lang.setTimeout=function(_24,_25){
var _26=window,argsStart=2;
if(!dojo.lang.isFunction(_24)){
_26=_24;
_24=_25;
_25=arguments[2];
argsStart++;
}
if(dojo.lang.isString(_24)){
_24=_26[_24];
}
var _27=[];
for(var i=argsStart;i<arguments.length;i++){
_27.push(arguments[i]);
}
return setTimeout(function(){
_24.apply(_26,_27);
},_25);
};
dojo.lang.isObject=function(wh){
return typeof wh=="object"||dojo.lang.isArray(wh)||dojo.lang.isFunction(wh);
};
dojo.lang.isArray=function(wh){
return (wh instanceof Array||typeof wh=="array");
};
dojo.lang.isArrayLike=function(wh){
if(dojo.lang.isString(wh)){
return false;
}
if(dojo.lang.isArray(wh)){
return true;
}
if(typeof wh!="undefined"&&wh&&dojo.lang.isNumber(wh.length)&&isFinite(wh.length)){
return true;
}
return false;
};
dojo.lang.isFunction=function(wh){
return (wh instanceof Function||typeof wh=="function");
};
dojo.lang.isString=function(wh){
return (wh instanceof String||typeof wh=="string");
};
dojo.lang.isAlien=function(wh){
return !dojo.lang.isFunction()&&/\{\s*\[native code\]\s*\}/.test(String(wh));
};
dojo.lang.isBoolean=function(wh){
return (wh instanceof Boolean||typeof wh=="boolean");
};
dojo.lang.isNumber=function(wh){
return (wh instanceof Number||typeof wh=="number");
};
dojo.lang.isUndefined=function(wh){
return ((wh==undefined)&&(typeof wh=="undefined"));
};
dojo.lang.whatAmI=function(wh){
try{
if(dojo.lang.isArray(wh)){
return "array";
}
if(dojo.lang.isFunction(wh)){
return "function";
}
if(dojo.lang.isString(wh)){
return "string";
}
if(dojo.lang.isNumber(wh)){
return "number";
}
if(dojo.lang.isBoolean(wh)){
return "boolean";
}
if(dojo.lang.isAlien(wh)){
return "alien";
}
if(dojo.lang.isUndefined(wh)){
return "undefined";
}
for(var _33 in dojo.lang.whatAmI.custom){
if(dojo.lang.whatAmI.custom[_33](wh)){
return _33;
}
}
if(dojo.lang.isObject(wh)){
return "object";
}
}
catch(E){
}
return "unknown";
};
dojo.lang.whatAmI.custom={};
dojo.lang.find=function(arr,val,_36){
if(!dojo.lang.isArrayLike(arr)&&dojo.lang.isArrayLike(val)){
var a=arr;
arr=val;
val=a;
}
var _38=dojo.lang.isString(arr);
if(_38){
arr=arr.split("");
}
if(_36){
for(var i=0;i<arr.length;++i){
if(arr[i]===val){
return i;
}
}
}else{
for(var i=0;i<arr.length;++i){
if(arr[i]==val){
return i;
}
}
}
return -1;
};
dojo.lang.indexOf=dojo.lang.find;
dojo.lang.findLast=function(arr,val,_3c){
if(!dojo.lang.isArrayLike(arr)&&dojo.lang.isArrayLike(val)){
var a=arr;
arr=val;
val=a;
}
var _3e=dojo.lang.isString(arr);
if(_3e){
arr=arr.split("");
}
if(_3c){
for(var i=arr.length-1;i>=0;i--){
if(arr[i]===val){
return i;
}
}
}else{
for(var i=arr.length-1;i>=0;i--){
if(arr[i]==val){
return i;
}
}
}
return -1;
};
dojo.lang.lastIndexOf=dojo.lang.findLast;
dojo.lang.inArray=function(arr,val){
return dojo.lang.find(arr,val)>-1;
};
dojo.lang.getNameInObj=function(ns,_43){
if(!ns){
ns=dj_global;
}
for(var x in ns){
if(ns[x]===_43){
return new String(x);
}
}
return null;
};
dojo.lang.has=function(obj,_46){
return (typeof obj[_46]!=="undefined");
};
dojo.lang.isEmpty=function(obj){
if(dojo.lang.isObject(obj)){
var tmp={};
var _49=0;
for(var x in obj){
if(obj[x]&&(!tmp[x])){
_49++;
break;
}
}
return (_49==0);
}else{
if(dojo.lang.isArrayLike(obj)||dojo.lang.isString(obj)){
return obj.length==0;
}
}
};
dojo.lang.forEach=function(arr,_4c,_4d){
var _4e=dojo.lang.isString(arr);
if(_4e){
arr=arr.split("");
}
var il=arr.length;
for(var i=0;i<((_4d)?il:arr.length);i++){
if(_4c(arr[i],i,arr)=="break"){
break;
}
}
};
dojo.lang.map=function(arr,obj,_53){
var _54=dojo.lang.isString(arr);
if(_54){
arr=arr.split("");
}
if(dojo.lang.isFunction(obj)&&(!_53)){
_53=obj;
obj=dj_global;
}else{
if(dojo.lang.isFunction(obj)&&_53){
var _55=obj;
obj=_53;
_53=_55;
}
}
if(Array.map){
var _56=Array.map(arr,_53,obj);
}else{
var _56=[];
for(var i=0;i<arr.length;++i){
_56.push(_53.call(obj,arr[i]));
}
}
if(_54){
return _56.join("");
}else{
return _56;
}
};
dojo.lang.tryThese=function(){
for(var x=0;x<arguments.length;x++){
try{
if(typeof arguments[x]=="function"){
var ret=(arguments[x]());
if(ret){
return ret;
}
}
}
catch(e){
dojo.debug(e);
}
}
};
dojo.lang.delayThese=function(_5a,cb,_5c,_5d){
if(!_5a.length){
if(typeof _5d=="function"){
_5d();
}
return;
}
if((typeof _5c=="undefined")&&(typeof cb=="number")){
_5c=cb;
cb=function(){
};
}else{
if(!cb){
cb=function(){
};
if(!_5c){
_5c=0;
}
}
}
setTimeout(function(){
(_5a.shift())();
cb();
dojo.lang.delayThese(_5a,cb,_5c,_5d);
},_5c);
};
dojo.lang.shallowCopy=function(obj){
var ret={},key;
for(key in obj){
if(dojo.lang.isUndefined(ret[key])){
ret[key]=obj[key];
}
}
return ret;
};
dojo.lang.every=function(arr,_61,_62){
var _63=dojo.lang.isString(arr);
if(_63){
arr=arr.split("");
}
if(Array.every){
return Array.every(arr,_61,_62);
}else{
if(!_62){
if(arguments.length>=3){
dojo.raise("thisObject doesn't exist!");
}
_62=dj_global;
}
for(var i=0;i<arr.length;i++){
if(!_61.call(_62,arr[i],i,arr)){
return false;
}
}
return true;
}
};
dojo.lang.some=function(arr,_66,_67){
var _68=dojo.lang.isString(arr);
if(_68){
arr=arr.split("");
}
if(Array.some){
return Array.some(arr,_66,_67);
}else{
if(!_67){
if(arguments.length>=3){
dojo.raise("thisObject doesn't exist!");
}
_67=dj_global;
}
for(var i=0;i<arr.length;i++){
if(_66.call(_67,arr[i],i,arr)){
return true;
}
}
return false;
}
};
dojo.lang.filter=function(arr,_6b,_6c){
var _6d=dojo.lang.isString(arr);
if(_6d){
arr=arr.split("");
}
if(Array.filter){
var _6e=Array.filter(arr,_6b,_6c);
}else{
if(!_6c){
if(arguments.length>=3){
dojo.raise("thisObject doesn't exist!");
}
_6c=dj_global;
}
var _6e=[];
for(var i=0;i<arr.length;i++){
if(_6b.call(_6c,arr[i],i,arr)){
_6e.push(arr[i]);
}
}
}
if(_6d){
return _6e.join("");
}else{
return _6e;
}
};
dojo.AdapterRegistry=function(){
this.pairs=[];
};
dojo.lang.extend(dojo.AdapterRegistry,{register:function(_70,_71,_72,_73){
if(_73){
this.pairs.unshift([_70,_71,_72]);
}else{
this.pairs.push([_70,_71,_72]);
}
},match:function(){
for(var i=0;i<this.pairs.length;i++){
var _75=this.pairs[i];
if(_75[1].apply(this,arguments)){
return _75[2].apply(this,arguments);
}
}
throw new Error("No match found");
},unregister:function(_76){
for(var i=0;i<this.pairs.length;i++){
var _78=this.pairs[i];
if(_78[0]==_76){
this.pairs.splice(i,1);
return true;
}
}
return false;
}});
dojo.lang.reprRegistry=new dojo.AdapterRegistry();
dojo.lang.registerRepr=function(_79,_7a,_7b,_7c){
dojo.lang.reprRegistry.register(_79,_7a,_7b,_7c);
};
dojo.lang.repr=function(obj){
if(typeof (obj)=="undefined"){
return "undefined";
}else{
if(obj===null){
return "null";
}
}
try{
if(typeof (obj["__repr__"])=="function"){
return obj["__repr__"]();
}else{
if((typeof (obj["repr"])=="function")&&(obj.repr!=arguments.callee)){
return obj["repr"]();
}
}
return dojo.lang.reprRegistry.match(obj);
}
catch(e){
if(typeof (obj.NAME)=="string"&&(obj.toString==Function.prototype.toString||obj.toString==Object.prototype.toString)){
return o.NAME;
}
}
if(typeof (obj)=="function"){
obj=(obj+"").replace(/^\s+/,"");
var idx=obj.indexOf("{");
if(idx!=-1){
obj=obj.substr(0,idx)+"{...}";
}
}
return obj+"";
};
dojo.lang.reprArrayLike=function(arr){
try{
var na=dojo.lang.map(arr,dojo.lang.repr);
return "["+na.join(", ")+"]";
}
catch(e){
}
};
dojo.lang.reprString=function(str){
return ("\""+str.replace(/(["\\])/g,"\\$1")+"\"").replace(/[\f]/g,"\\f").replace(/[\b]/g,"\\b").replace(/[\n]/g,"\\n").replace(/[\t]/g,"\\t").replace(/[\r]/g,"\\r");
};
dojo.lang.reprNumber=function(num){
return num+"";
};
(function(){
var m=dojo.lang;
m.registerRepr("arrayLike",m.isArrayLike,m.reprArrayLike);
m.registerRepr("string",m.isString,m.reprString);
m.registerRepr("numbers",m.isNumber,m.reprNumber);
m.registerRepr("boolean",m.isBoolean,m.reprNumber);
})();
dojo.lang.unnest=function(){
var out=[];
for(var i=0;i<arguments.length;i++){
if(dojo.lang.isArrayLike(arguments[i])){
var add=dojo.lang.unnest.apply(this,arguments[i]);
out=out.concat(add);
}else{
out.push(arguments[i]);
}
}
return out;
};
dojo.lang.firstValued=function(){
for(var i=0;i<arguments.length;i++){
if(typeof arguments[i]!="undefined"){
return arguments[i];
}
}
return undefined;
};
dojo.lang.toArray=function(_88,_89){
var _8a=[];
for(var i=_89||0;i<_88.length;i++){
_8a.push(_88[i]);
}
return _8a;
};

