dojo.provide("dojo.widget.EditorTree");
dojo.require("dojo.event.*");
dojo.require("dojo.dnd.*");
dojo.require("dojo.fx.html");
dojo.require("dojo.io.*");
dojo.require("dojo.widget.Container");
dojo.require("dojo.widget.Tree");
dojo.require("dojo.widget.EditorTreeNode");
dojo.widget.tags.addParseTreeHandler("dojo:EditorTree");
dojo.widget.EditorTree=function(){
dojo.widget.html.Container.call(this);
this.acceptDropSources=[];
this.eventNames={nodeCreate:"",treeClick:"",iconClick:"",titleClick:""};
};
dojo.inherits(dojo.widget.EditorTree,dojo.widget.html.Container);
dojo.lang.extend(dojo.widget.EditorTree,{widgetType:"EditorTree",domNode:null,templateCssPath:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/EditorTree.css"),templateString:"<div class=\"dojoTree\"></div>",eventNames:null,toggler:null,blankIconSrc:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/treenode_blank.gif").toString(),gridIconSrcT:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/treenode_grid_t.gif").toString(),gridIconSrcL:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/treenode_grid_l.gif").toString(),gridIconSrcV:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/treenode_grid_v.gif").toString(),gridIconSrcP:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/treenode_grid_p.gif").toString(),gridIconSrcC:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/treenode_grid_c.gif").toString(),gridIconSrcX:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/treenode_grid_x.gif").toString(),gridIconSrcY:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/treenode_grid_y.gif").toString(),gridIconSrcZ:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/treenode_grid_z.gif").toString(),expandIconSrcPlus:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/treenode_expand_plus.gif").toString(),expandIconSrcMinus:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/treenode_expand_minus.gif").toString(),expandIconSrcLoading:dojo.uri.dojoUri("src/widget/templates/images/EditorTree/treenode_loading.gif").toString(),iconWidth:18,iconHeight:18,showGrid:true,showRootGrid:true,toggle:"default",toggleDuration:150,title:"My Tree",selector:null,initialize:function(_1,_2){
var _3;
if((_3=_1["acceptDropSources"])||(_3=_1["acceptDropSources"])){
this.acceptDropSources=_3.split(",");
}
switch(this.toggle){
case "fade":
this.toggler=new dojo.widget.Tree.FadeToggle();
break;
case "wipe":
this.toggler=new dojo.widget.Tree.WipeToggle();
break;
default:
this.toggler=new dojo.widget.Tree.DefaultToggle();
}
if(_1["eventNaming"]=="default"||_1["eventnaming"]=="default"){
for(eventName in this.eventNames){
this.eventNames[eventName]=this.widgetId+"/"+eventName;
}
}
if(_1["controller"]){
var _4=dojo.widget.manager.getWidgetById(_1["controller"]);
_4.subscribeTree(this);
}
if(_1["selector"]){
this.selector=dojo.widget.manager.getWidgetById(_1["selector"]);
}else{
this.selector=new dojo.widget.createWidget("dojo.widget.EditorTreeSelector");
}
},postCreate:function(){
this.buildTree();
},buildTree:function(){
dojo.html.disableSelection(this.domNode);
for(var i=0;i<this.children.length;i++){
this.children[i].isFirstNode=(i==0)?true:false;
this.children[i].isLastNode=(i==this.children.length-1)?true:false;
this.children[i].parentNode=this;
var _6=this.children[i].buildNode(this,0);
this.domNode.appendChild(_6);
}
if(!this.showRootGrid){
for(var i=0;i<this.children.length;i++){
this.children[i].expand();
}
}
for(var i=0;i<this.children.length;i++){
this.children[i].startMe();
}
},changeParent:function(_7,_8){
_7.parentNode.removeChild(_7);
_8.addChild(_7,0);
},removeChild:function(_9){
var _a=_9.parentNode;
var _b=_a.children;
for(var i=0;i<_b.length;i++){
if(_b[i]===_9){
if(_b.length>1){
if(i==0){
_b[i+1].isFirstNode=true;
}
if(i==_b.length-1){
_b[i-1].isLastNode=true;
}
}
_b.splice(i,1);
break;
}
}
_9.domNode.parentNode.removeChild(_9.domNode);
if(_b.length==0){
if(_a.widgetType=="EditorTreeNode"){
_a.containerNode.style.display="none";
}
}
_a.updateIconTree();
return _9;
},addChild:function(_d,_e){
if(dojo.lang.isUndefined(_e)){
_e=this.children.length;
}
if(_d.widgetType!="EditorTreeNode"){
dojo.raise("You can only add EditorTreeNode widgets to a "+this.widgetType+" widget!");
return;
}
if(this.children.length){
if(_e==0){
this.children[0].isFirstNode=false;
_d.isFirstNode=true;
}else{
_d.isFirstNode=false;
}
if(_e==this.children.length){
this.children[_e-1].isLastNode=false;
_d.isLastNode=true;
}else{
_d.isLastNode=false;
}
}else{
_d.isLastNode=true;
_d.isFirstNode=true;
}
if(this.widgetType=="EditorTreeNode"){
this.isFolder=true;
}
var _f=this.widgetType=="EditorTreeNode"?this.tree:this;
dojo.lang.forEach(_d.getDescendants(),function(_10){
_10.tree=_f;
});
_d.parentNode=this;
if(this.widgetType=="EditorTreeNode"){
this.loaded=this.loadStates.LOADED;
}
if(_d.domNodeInitialized){
var d=(this.widgetType=="EditorTreeNode")?this.depth:0;
_d.adjustDepth(d-_d.depth+1);
}else{
_d.depth=this.widgetType=="EditorTreeNode"?this.depth+1:0;
_d.buildNode(_d.tree,_d.depth);
}
if(_e<this.children.length){
this.children[_e].domNode.parentNode.insertBefore(_d.domNode,this.children[_e].domNode);
}else{
if(this.widgetType=="EditorTree"){
this.domNode.appendChild(node);
}else{
this.containerNode.style.display="block";
this.containerNode.appendChild(_d.domNode);
}
}
this.children.splice(_e,0,_d);
this.updateIconTree();
_d.startMe();
},makeBlankImg:function(){
var img=document.createElement("img");
img.style.width=this.iconWidth+"px";
img.style.height=this.iconHeight+"px";
img.src=this.blankIconSrc;
img.style.verticalAlign="middle";
return img;
},swapNodes:function(_13,_14){
if(_13===_14){
return;
}
if(_13.parentNode!==_14.parentNode){
dojo.raise("You may only swap nodes with same parent");
}
var _15=_13.parentNode;
var _16=_13.getParentIndex();
var _17=_14.getParentIndex();
_15.children[_16]=_14;
_15.children[_17]=_13;
var a=_13.isLastNode;
var b=_13.isFirstNode;
_13.isLastNode=_14.isLastNode;
_13.isFirstNode=_14.isFirstNode;
_14.isLastNode=a;
_14.isFirstNode=b;
this.swapDomNodes(_13.domNode,_14.domNode);
_15.updateIconTree();
},swapDomNodes:function(_1a,_1b){
if(_1b.nextSibling===_1a){
return this.swapDomNodes(_1b,_1a);
}
var _1c=_1a.parentNode;
var _1d=_1b.parentNode;
var _1e;
var _1f;
var _20;
var _21;
if(_1a.nextSibling===_1b){
if(_1b.nextSibling){
var a2n=_1b.nextSibling;
_1e=function(_23){
_1c.insertBefore(_23,a2n);
};
_1f=function(_24){
_1c.insertBefore(_24,a2n);
};
}else{
_1e=function(_25){
_1c.appendChild(_25);
};
_1f=function(_26){
_1c.appendChild(_26);
};
}
}else{
if(_1a.nextSibling){
_1e=function(_27){
_1c.insertBefore(_27,_1a.nextSibling);
};
}else{
_1e=function(_28){
_1c.appendChild(_28);
};
}
if(_1b.nextSibling){
_1f=function(_29){
_1d.insertBefore(_29,_1b.nextSibling);
};
}else{
_1f=function(_2a){
_1d.appendChild(_2a);
};
}
}
_20=_1c.removeChild(_1a);
_21=_1d.removeChild(_1b);
_1e.apply(this,[_21]);
_1f.apply(this,[_20]);
},updateIconTree:function(){
if(this.widgetType=="EditorTreeNode"){
this.updateIcons();
}
for(var i=0;i<this.children.length;i++){
this.children[i].updateIconTree();
}
}});

