dojo.provide("dojo.widget.InlineEditBox");
dojo.provide("dojo.widget.html.InlineEditBox");
dojo.require("dojo.widget.*");
dojo.require("dojo.fx.*");
dojo.require("dojo.graphics.color");
dojo.require("dojo.string");
dojo.require("dojo.style");
dojo.require("dojo.html");
dojo.widget.tags.addParseTreeHandler("dojo:inlineeditbox");
dojo.widget.html.InlineEditBox=function(){
dojo.widget.HtmlWidget.call(this);
this.history=[];
this.storage=document.createElement("span");
};
dojo.inherits(dojo.widget.html.InlineEditBox,dojo.widget.HtmlWidget);
dojo.lang.extend(dojo.widget.html.InlineEditBox,{templatePath:dojo.uri.dojoUri("src/widget/templates/HtmlInlineEditBox.html"),templateCssPath:dojo.uri.dojoUri("src/widget/templates/HtmlInlineEditBox.css"),widgetType:"InlineEditBox",form:null,editBox:null,edit:null,text:null,textarea:null,submitButton:null,cancelButton:null,mode:"text",minWidth:100,minHeight:200,editing:false,textValue:"",defaultText:"",doFade:false,onSave:function(_1,_2){
},onUndo:function(_3){
},buildRendering:function(_4,_5){
this.nodeRef=_5["dojo:"+this.widgetType.toLowerCase()]["nodeRef"];
var _6=this.nodeRef;
if(_6.normalize){
_6.normalize();
}
dojo.widget.buildAndAttachTemplate(this);
this.editable=document.createElement("span");
while(_6.firstChild){
this.editable.appendChild(_6.firstChild);
}
this.textValue=dojo.string.trim(this.editable.innerHTML);
if(dojo.string.trim(this.textValue).length==0){
this.editable.innerHTML=this.defaultText;
}
_6.appendChild(this.editable);
var _7=this;
setTimeout(function(){
_7.editable.appendChild(_7.edit);
},30);
dojo.event.connect(this.editable,"onmouseover",this,"mouseover");
dojo.event.connect(this.editable,"onmouseout",this,"mouseout");
dojo.event.connect(this.editable,"onclick",this,"beginEdit");
this.fillInTemplate(_4,_5);
},mouseover:function(e){
if(!this.editing){
dojo.html.addClass(this.editable,"editableRegion");
if(this.mode=="textarea"){
dojo.html.addClass(this.editable,"editableTextareaRegion");
}
}
},mouseout:function(e){
if(!this.editing){
dojo.html.removeClass(this.editable,"editableRegion");
dojo.html.removeClass(this.editable,"editableTextareaRegion");
}
},beginEdit:function(e){
if(this.editing){
return;
}
this.mouseout();
this.editing=true;
var ee=this[this.mode.toLowerCase()];
ee.style.display="";
ee.value=dojo.string.trim(this.textValue);
ee.style.fontSize=dojo.style.getStyle(this.editable,"font-size");
ee.style.fontWeight=dojo.style.getStyle(this.editable,"font-weight");
ee.style.fontStyle=dojo.style.getStyle(this.editable,"font-style");
ee.style.width=Math.max(dojo.html.getInnerWidth(this.editable),this.minWidth)+"px";
if(this.mode.toLowerCase()=="textarea"){
ee.style.display="block";
ee.style.height=Math.max(dojo.html.getInnerHeight(this.editable),this.minHeight)+"px";
}
this.editable.style.display="none";
this.nodeRef.appendChild(this.form);
ee.select();
this.submitButton.disabled=true;
},saveEdit:function(e){
e.preventDefault();
e.stopPropagation();
var ee=this[this.mode.toLowerCase()];
if((this.textValue!=ee.value)&&(dojo.string.trim(ee.value)!="")){
this.doFade=true;
this.history.push(this.textValue);
this.onSave(ee.value,this.textValue);
this.textValue=ee.value;
this.editable.innerHTML=this.textValue;
}else{
this.doFade=false;
}
this.finishEdit(e);
},cancelEdit:function(e){
if(!this.editing){
return false;
}
this.editing=false;
this.nodeRef.removeChild(this.form);
this.editable.style.display="";
return true;
},finishEdit:function(e){
if(!this.cancelEdit(e)){
return;
}
if(this.doFade){
dojo.fx.highlight(this.editable,dojo.graphics.color.hex2rgb("#ffc"),700,300);
}
this.doFade=false;
},setText:function(txt){
var tt=dojo.string.trim(txt);
this.textValue=tt;
this.editable.innerHTML=tt;
},undo:function(){
if(this.history.length>0){
var _12=this.history.pop();
this.editable.innerHTML=_12;
this.textValue=_12;
this.onUndo(_12);
}
},checkForValueChange:function(){
var ee=this[this.mode.toLowerCase()];
if((this.textValue!=ee.value)&&(dojo.string.trim(ee.value)!="")){
this.submitButton.disabled=false;
}
}});

