dojo.provide("dojo.widget.Tabs");
dojo.provide("dojo.widget.html.Tabs");
dojo.deprecated("dojo.widget.Tabs","use dojo.widget.TabPane","0.3");
dojo.require("dojo.io.*");
dojo.require("dojo.widget.*");
dojo.require("dojo.dom");
dojo.require("dojo.html");
dojo.widget.tags.addParseTreeHandler("dojo:tabs");
dojo.widget.html.Tabs=function(){
dojo.widget.HtmlWidget.call(this);
this.tabs=[];
this.panels=[];
};
dojo.inherits(dojo.widget.html.Tabs,dojo.widget.HtmlWidget);
dojo.lang.extend(dojo.widget.html.Tabs,{widgetType:"Tabs",isContainer:true,templatePath:null,templateCssPath:dojo.uri.dojoUri("src/widget/templates/HtmlTabs.css"),domNode:null,containerNode:null,selected:-1,tabTarget:"",extractContent:false,parseContent:false,preventCache:false,buildRendering:function(_1,_2){
dojo.style.insertCssFile(this.templateCssPath);
this.domNode=_2["dojo:"+this.widgetType.toLowerCase()]["nodeRef"];
if(!this.domNode){
dj_error("html.Tabs: No node reference");
}
if(_1["tabtarget"]){
this.tabtarget=_1["tabtarget"];
this.containerNode=document.getElementById(_1["tabtarget"]);
}else{
this.containerNode=document.createElement("div");
var _3=this.domNode.nextSibling;
if(_3){
this.domNode.parentNode.insertBefore(this.containerNode,_3);
}else{
this.domNode.parentNode.appendChild(this.containerNode);
}
}
dojo.html.addClass(this.containerNode,"dojoTabPanelContainer");
var li=dojo.dom.getFirstChildElement(this.domNode);
while(li){
var a=li.getElementsByTagName("a").item(0);
this.addTab(a);
li=dojo.dom.getNextSiblingElement(li);
}
if(this.selected==-1){
this.selected=0;
}
this.selectTab(null,this.tabs[this.selected]);
},addTab:function(_6,_7,_8,_9){
var _a={url:null,title:null,isLoaded:false,id:null,isLocal:false};
function isLocal(a){
var _c=a.getAttribute("href");
var _d=_c.indexOf("#");
if(_d==0){
return true;
}
var _e=location.href.split("#")[0];
var _f=_c.split("#")[0];
if(_e==_f){
return true;
}
if(unescape(_e)==_f){
return true;
}
var _10=a.outerHTML;
if(_10&&/href=["']?#/i.test(_10)){
return true;
}
return false;
}
if(_6&&_6.tagName&&_6.tagName.toLowerCase()=="a"){
var a=_6;
var li=a.parentNode;
_6=a.innerHTML;
_7=a.getAttribute("href");
var id=null;
var _14=_7.indexOf("#");
if(isLocal(a)){
id=_7.split("#")[1];
dj_debug("setting local id:",id);
_7="#"+id;
_a.isLocal=true;
}else{
id=a.getAttribute("tabid");
}
_a.url=_7;
_a.title=_6;
_a.id=id||dojo.html.getUniqueId();
dj_debug("panel id:",_a.id,"url:",_a.url);
}else{
var li=document.createElement("li");
var a=document.createElement("a");
a.innerHTML=_6;
a.href=_7;
li.appendChild(a);
this.domNode.appendChild(li);
_a.url=_7;
_a.title=_6;
_a.id=_8||dojo.html.getUniqueId();
dj_debug("prg tab:",_a.id,"url:",_a.url);
}
if(_a.isLocal){
var _15=document.getElementById(id);
_15.style.display="none";
this.containerNode.appendChild(_15);
}else{
var _15=document.createElement("div");
_15.style.display="none";
_15.id=_a.id;
this.containerNode.appendChild(_15);
}
var _16=a.getAttribute("tabhandler")||_9;
if(_16){
this.setPanelHandler(_16,_a);
}
dojo.event.connect(a,"onclick",this,"selectTab");
this.tabs.push(li);
this.panels.push(_a);
if(this.selected==-1&&dojo.html.hasClass(li,"current")){
this.selected=this.tabs.length-1;
}
return {"tab":li,"panel":_a};
},selectTab:function(e,_18){
if(dojo.lang.isNumber(e)){
_18=this.tabs[e];
}else{
if(e){
if(e.target){
_18=e.target;
while(_18&&(_18.tagName||"").toLowerCase()!="li"){
_18=_18.parentNode;
}
}
if(e.preventDefault){
e.preventDefault();
}
}
}
dojo.html.removeClass(this.tabs[this.selected],"current");
for(var i=0;i<this.tabs.length;i++){
if(this.tabs[i]==_18){
dojo.html.addClass(this.tabs[i],"current");
this.selected=i;
break;
}
}
var _1a=this.panels[this.selected];
if(_1a){
this.getPanel(_1a);
this.hidePanels(_1a);
document.getElementById(_1a.id).style.display="";
}
},setPanelHandler:function(_1b,_1c){
var fcn=dojo.lang.isFunction(_1b)?_1b:window[_1b];
if(!dojo.lang.isFunction(fcn)){
throw new Error("Unable to set panel handler, '"+_1b+"' not a function.");
return;
}
this["tabHandler"+_1c.id]=function(){
return fcn.apply(this,arguments);
};
},runPanelHandler:function(_1e){
if(dojo.lang.isFunction(this["tabHandler"+_1e.id])){
this["tabHandler"+_1e.id](_1e,document.getElementById(_1e.id));
return false;
}
return true;
},getPanel:function(_1f){
if(this.runPanelHandler(_1f)){
if(_1f.isLocal){
}else{
if(!_1f.isLoaded||!this.useCache){
this.setExternalContent(_1f,_1f.url,this.useCache,this.preventCache);
}
}
}
},setExternalContent:function(_20,url,_22,_23){
var _24=document.getElementById(_20.id);
_24.innerHTML="Loading...";
var _25=this.extractContent;
var _26=this.parseContent;
dojo.io.bind({url:url,useCache:_22,preventCache:_23,mimetype:"text/html",handler:function(_27,_28,e){
if(_27=="load"){
if(_25){
var _2a=_28.match(/<body[^>]*>\s*([\s\S]+)\s*<\/body>/im);
if(_2a){
_28=_2a[1];
}
}
_24.innerHTML=_28;
_20.isLoaded=true;
if(_26){
var _2b=new dojo.xml.Parse();
var _2c=_2b.parseElement(_24,null,true);
dojo.widget.getParser().createComponents(_2c);
}
}else{
_24.innerHTML="Error loading '"+_20.url+"' ("+e.status+" "+e.statusText+")";
}
}});
},hidePanels:function(_2d){
for(var i=0;i<this.panels.length;i++){
if(this.panels[i]!=_2d&&this.panels[i].id){
var p=document.getElementById(this.panels[i].id);
if(p){
p.style.display="none";
}
}
}
}});

