dojo.provide("dojo.widget.html.ComboBox");
dojo.require("dojo.widget.ComboBox");
dojo.require("dojo.widget.*");
dojo.require("dojo.io.*");
dojo.require("dojo.fx.*");
dojo.require("dojo.dom");
dojo.require("dojo.html");
dojo.require("dojo.string");
dojo.require("dojo.widget.html.stabile");
dojo.widget.html.ComboBox=function(){
dojo.widget.ComboBox.call(this);
dojo.widget.HtmlWidget.call(this);
this.autoComplete=true;
this.formInputName="";
this.name="";
this.textInputNode=null;
this.comboBoxValue=null;
this.comboBoxSelectionValue=null;
this.optionsListWrapper=null;
this.optionsListNode=null;
this.downArrowNode=null;
this.cbTableNode=null;
this.searchTimer=null;
this.searchDelay=100;
this.dataUrl="";
this.mode="local";
this.selectedResult=null;
this._highlighted_option=null;
this._prev_key_backspace=false;
this._prev_key_esc=false;
this._result_list_open=false;
};
dojo.inherits(dojo.widget.html.ComboBox,dojo.widget.HtmlWidget);
dojo.lang.extend(dojo.widget.html.ComboBox,dojo.widget.ComboBox.defaults);
dojo.lang.extend(dojo.widget.html.ComboBox,{templatePath:dojo.uri.dojoUri("src/widget/templates/HtmlComboBox.html"),templateCssPath:dojo.uri.dojoUri("src/widget/templates/HtmlComboBox.css"),setValue:function(_1){
this.comboBoxValue.value=this.textInputNode.value=_1;
dojo.widget.html.stabile.setState(this.widgetId,this.getState(),true);
},getValue:function(){
return this.comboBoxValue.value;
},getState:function(){
return {value:this.getValue()};
},setState:function(_2){
this.setValue(_2.value);
},getCaretPos:function(_3){
if(dojo.render.html.mozilla){
return _3.selectionStart;
}else{
if(dojo.render.html.ie){
var tr=document.selection.createRange().duplicate();
var _5=_3.createTextRange();
tr.move("character",0);
_5.move("character",0);
_5.setEndPoint("EndToEnd",tr);
return String(_5.text).replace(/\r/g,"").length;
}
}
},setCaretPos:function(_6,_7){
_7=parseInt(_7);
this.setSelectedRange(_6,_7,_7);
},setSelectedRange:function(_8,_9,_a){
if(!_a){
_a=_8.value.length;
}
if(_8.setSelectionRange){
_8.focus();
_8.setSelectionRange(_9,_a);
}else{
if(_8.createTextRange){
var _b=_8.createTextRange();
with(_b){
collapse(true);
moveEnd("character",_a);
moveStart("character",_9);
select();
}
}else{
_8.value=_8.value;
_8.blur();
_8.focus();
var _c=parseInt(_8.value.length)-_a;
var _d=String.fromCharCode(37);
var _e=_d.charCodeAt(0);
for(var x=0;x<_c;x++){
var te=document.createEvent("KeyEvents");
te.initKeyEvent("keypress",true,true,null,false,false,false,false,_e,_e);
twe.dispatchEvent(te);
}
}
}
},killEvent:function(evt){
evt.preventDefault();
evt.stopPropagation();
},onKeyDown:function(evt){
},setSelectedValue:function(_13){
this.comboBoxSelectionValue.value=_13;
this.hideResultList();
},highlightNextOption:function(){
if(this._highlighted_option){
dojo.html.removeClass(this._highlighted_option,"cbItemHighlight");
}
if((!this._highlighted_option)||(!this._highlighted_option.nextSibling)){
this._highlighted_option=this.optionsListNode.firstChild;
}else{
this._highlighted_option=this._highlighted_option.nextSibling;
}
dojo.html.addClass(this._highlighted_option,"cbItemHighlight");
},highlightPrevOption:function(){
if(this._highlighted_option){
dojo.html.removeClass(this._highlighted_option,"cbItemHighlight");
}
if((!this._highlighted_option)||(!this._highlighted_option.previousSibling)){
this._highlighted_option=this.optionsListNode.lastChild;
}else{
this._highlighted_option=this._highlighted_option.previousSibling;
}
dojo.html.addClass(this._highlighted_option,"cbItemHighlight");
},onKeyUp:function(evt){
if(evt.keyCode==27){
this.hideResultList();
if(this._prev_key_esc){
this.textInputNode.blur();
this.selectedResult=null;
}
this._prev_key_esc=true;
return;
}else{
if((evt.keyCode==32)||(evt.keyCode==13)){
if(this._result_list_open){
evt={target:this._highlighted_option};
this.selectOption(evt);
}else{
this.selectOption();
}
return;
}else{
if(evt.keyCode==40){
if(!this._result_list_open){
this.startSearchFromInput();
}
this.highlightNextOption();
return;
}else{
if(evt.keyCode==38){
this.highlightPrevOption();
return;
}else{
this.setValue(this.textInputNode.value);
}
}
}
}
this._prev_key_backspace=(evt.keyCode==8)?true:false;
this._prev_key_esc=false;
if(this.searchTimer){
clearTimeout(this.searchTimer);
}
if((this._prev_key_backspace)&&(!this.textInputNode.value.length)){
this.hideResultList();
}else{
this.searchTimer=setTimeout(dojo.lang.hitch(this,this.startSearchFromInput),this.searchDelay);
}
},fillInTemplate:function(_15,_16){
this.comboBoxValue.name=this.name;
this.comboBoxSelectionValue.name=this.name+"_selected";
var _17=this.getFragNodeRef(_16).style;
if(_17){
this.domNode.style.cssText=_17.cssText;
}
this.dataProvider=new dojo.widget.ComboBoxDataProvider();
if(!dojo.string.isBlank(this.dataUrl)){
if("local"==this.mode){
var _18=this;
dojo.io.bind({url:this.dataUrl,load:function(_19,_1a,evt){
if(_19=="load"){
_18.dataProvider.setData(_1a);
}
},mimetype:"text/javascript"});
}else{
if("remote"==this.mode){
this.dataProvider=new dojo.widget.incrementalComboBoxDataProvider(this.dataUrl);
}
}
}else{
var _1c=_16["dojo:"+this.widgetType.toLowerCase()]["nodeRef"];
if((_1c)&&(_1c.nodeName.toLowerCase()=="select")){
var _1d=_1c.getElementsByTagName("option");
var ol=_1d.length;
var _1f=[];
for(var x=0;x<ol;x++){
_1f.push([new String(_1d[x].innerHTML),new String(_1d[x].value)]);
}
this.dataProvider.setData(_1f);
}
}
this.bgIframe=new dojo.html.BackgroundIframe();
if(this.bgIframe.iframe){
this.optionsListWrapper.appendChild(this.bgIframe.iframe);
}
},openResultList:function(_21){
this.clearResultList();
if(!_21.length){
this.hideResultList();
}else{
this.showResultList();
}
if((this.autoComplete)&&(_21.length)&&(!this._prev_key_backspace)&&(this.textInputNode.value.length>0)){
var _22=this.getCaretPos(this.textInputNode);
if((_22+1)>=this.textInputNode.value.length){
this.textInputNode.value=_21[0][0];
this.setSelectedRange(this.textInputNode,_22,this.textInputNode.value.length);
}
}
var _23=true;
while(_21.length){
var tr=_21.shift();
if(tr){
var td=document.createElement("div");
td.appendChild(document.createTextNode(tr[0]));
td.setAttribute("resultName",tr[0]);
td.setAttribute("resultValue",tr[1]);
td.className="cbItem "+((_23)?"cbItemEven":"cbItemOdd");
_23=(!_23);
this.optionsListNode.appendChild(td);
}
}
dojo.event.kwConnect({once:true,srcObj:dojo.html.body(),srcFunc:"onclick",adviceObj:this,adviceFunc:"hideResultList"});
dojo.lang.setTimeout(this,"showBackgroundIframe",100);
},showBackgroundIframe:function(){
var w=dojo.style.getOuterWidth(this.optionsListNode);
var h=dojo.style.getOuterHeight(this.optionsListNode);
if(isNaN(w)||isNaN(h)){
dojo.lang.setTimeout(this,"showBackgroundIframe",100);
return;
}
this.bgIframe.show([0,0,w,h]);
this.bgIframe.setZIndex(1);
},selectOption:function(evt){
if(!evt){
evt={target:this._highlighted_option};
}
if(!dojo.dom.isDescendantOf(evt.target,this.optionsListNode)){
return;
}
var tgt=evt.target;
while((tgt.nodeType!=1)||(!tgt.getAttribute("resultName"))){
tgt=tgt.parentNode;
if(tgt===dojo.html.body()){
return false;
}
}
this.textInputNode.value=tgt.getAttribute("resultName");
this.selectedResult=[tgt.getAttribute("resultName"),tgt.getAttribute("resultValue")];
this.setValue(tgt.getAttribute("resultName"));
this.comboBoxSelectionValue.value=tgt.getAttribute("resultValue");
this.hideResultList();
},clearResultList:function(){
var oln=this.optionsListNode;
while(oln.firstChild){
oln.removeChild(oln.firstChild);
}
},hideResultList:function(){
dojo.fx.fadeHide(this.optionsListNode,200);
dojo.event.disconnect(dojo.html.body(),"onclick",this,"hideResultList");
this._result_list_open=false;
this.bgIframe.hide();
return;
},showResultList:function(){
if(this._result_list_open){
return;
}
with(this.optionsListNode.style){
display="";
height="";
width=dojo.html.getInnerWidth(this.downArrowNode)+dojo.html.getInnerWidth(this.textInputNode)+"px";
if(dojo.render.html.khtml){
marginTop=dojo.html.totalOffsetTop(this.optionsListNode.parentNode)+"px";
}
}
dojo.html.setOpacity(this.optionsListNode,0);
dojo.fx.fadeIn(this.optionsListNode,200);
this._result_list_open=true;
},handleArrowClick:function(){
if(this._result_list_open){
this.hideResultList();
}else{
this.startSearchFromInput();
}
},startSearchFromInput:function(){
this.startSearch(this.textInputNode.value);
},postCreate:function(){
dojo.event.connect(this,"startSearch",this.dataProvider,"startSearch");
dojo.event.connect(this.dataProvider,"provideSearchResults",this,"openResultList");
var s=dojo.widget.html.stabile.getState(this.widgetId);
if(s){
this.setState(s);
}
}});

