dojo.provide("dojo.widget.html.DropdownButton");
dojo.require("dojo.event.*");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.uri.Uri");
dojo.require("dojo.dom");
dojo.require("dojo.style");
dojo.require("dojo.html");
dojo.widget.html.DropdownButton=function(){
dojo.widget.DropdownButton.call(this);
dojo.widget.HtmlWidget.call(this);
};
dojo.inherits(dojo.widget.html.DropdownButton,dojo.widget.HtmlWidget);
dojo.lang.extend(dojo.widget.html.DropdownButton,{templatePath:dojo.uri.dojoUri("src/widget/templates/HtmlDropDownButtonTemplate.html"),templateCssPath:dojo.uri.dojoUri("src/widget/templates/HtmlButtonTemplate.css"),button:null,table:null,labelCell:null,borderCell:null,arrowCell:null,arrow:null,fillInTemplate:function(_1,_2){
var _3=_2["dojo:"+this.widgetType.toLowerCase()]["nodeRef"];
var _4=new dojo.xml.Parse();
var _2=_4.parseElement(_3,null,true);
var _5=dojo.widget.getParser().createComponents(_2);
this.a=dojo.dom.getFirstChildElement(_3);
this.menu=dojo.dom.getNextSiblingElement(this.a);
this.disabled=dojo.html.hasClass(this.a,"disabled");
if(this.disabled){
dojo.html.addClass(this.button,"dojoDisabled");
this.domNode.setAttribute("disabled","true");
}
dojo.html.disableSelection(this.a);
this.a.style["text-decoration"]="none";
this.labelCell.appendChild(this.a);
this.arrow.src=dojo.uri.dojoUri("src/widget/templates/images/dropdownButtonsArrow"+(this.disabled?"-disabled":"")+".gif");
this.menu.style.position="absolute";
this.menu.style.display="none";
this.menu.style["z-index"]=99;
dojo.html.body().appendChild(this.menu);
},postCreate:function(){
if(dojo.render.html.ie){
var _6=dojo.style.getOuterWidth(this.table);
this.labelCell.style["left"]="-"+(_6/10)+"px";
this.arrowCell.style["left"]=(_6/10)+"px";
}
var _7=dojo.style.getOuterWidth(this.button);
var _8=dojo.style.getOuterWidth(this.menu);
if(_7>_8){
dojo.style.setOuterWidth(this.menu,_7);
}
},onCanvasMouseDown:function(e){
if(!dojo.dom.isDescendantOf(e.target,this.button)&&!dojo.dom.isDescendantOf(e.target,this.menu)){
this.hideMenu();
}
},eventWasOverArrow:function(e){
var _b=e.clientX;
var _c=dojo.style.totalOffsetLeft(this.borderCell);
return (_b>_c);
},onMouseOver:function(e){
dojo.html.addClass(this.button,"dojoButtonHover");
dojo.html.removeClass(this.button,"dojoButtonNoHover");
},onMouseOut:function(e){
dojo.html.removeClass(this.button,"dojoButtonHover");
dojo.html.addClass(this.button,"dojoButtonNoHover");
},onClick:function(e){
if(this.eventWasOverArrow(e)){
this._onClickArrow();
}else{
this._onClickButton();
}
},_onClickButton:function(e){
if(this.a){
if(this.a.click){
this.a.click();
}else{
if(this.a.href){
location.href=this.a.href;
}
}
}
},_onClickArrow:function(){
if(this.menu.style.display=="none"){
this.showMenu();
}else{
this.hideMenu();
}
},showMenu:function(){
if(this.disabled){
return;
}
this.menu.style.left=dojo.style.totalOffsetLeft(this.button)+"px";
this.menu.style.top=dojo.style.totalOffsetTop(this.button)+dojo.style.getOuterHeight(this.button)+"px";
try{
this.menu.style.display="table";
}
catch(e){
this.menu.style.display="block";
}
dojo.event.connect(document.documentElement,"onmousedown",this,"onCanvasMouseDown");
dojo.event.connect(this.menu,"onclick",this,"hideMenu");
},hideMenu:function(){
this.menu.style.display="none";
dojo.event.disconnect(document.documentElement,"onmousedown",this,"onCanvasMouseDown");
dojo.event.disconnect(this.menu,"onclick",this,"hideMenu");
}});

